
// *****************************************************************************
//
// source:    AC_RICH_evnt.C
//
// type:      source code
//
// created:   03 Nov 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_RICH_evnt()
//
// called by: AC_evnt()
//
// hints:     see $HBROOT/ARTE/dev/include/dq/DQ.h for COMP_XYZ and LVL_ABC
//
// changes:
// 03 Nov 1999 (AG) further developments
// 19 Nov 1999 (AG) cna -> ac (alca)
// 22 Nov 1999 (AG) includes in alca
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "dq/DQ.h"
#include "alca/AC_RICH.hh"

//
// program code
//
int
AC_RICH_evnt()
{
  // track loop
  for( ArteTableIterator<RSEG> track; track.valid(); track.next() ){

    // Cherenkov angle
    if( track->cmp == Rsegc::rich ){
      rhp_hf1( AC_ID( COMP_RICH, LVL_TST, 1 ), track->time, 1 );
    }

  }
  
  return 0;
}
