
// *****************************************************************************
//
// source:    AC_RICH_init.C
//
// type:      source code
//
// created:   03 Nov 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_RICH_init()
//
// called by: AC_init()
//
// hints:     see $HBROOT/ARTE/dev/include/dq/DQ.h for COMP_XYZ and LVL_ABC
//
// changes:
// 03 Nov 1999 (AG) further developments
// 19 Nov 1999 (AG) cna -> ac (alca)
// 22 Nov 1999 (AG) includes in alca
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "dq/DQ.h"
#include "alca/AC_RICH.hh"

//
// program code
//
int
AC_RICH_init()
{
  // show up
  cout << "AC_RICH_init()" << endl;

  // book histogram
  rhp_hbook1( AC_ID( COMP_RICH, LVL_TST, 1 ),
	      "RICH: Cherenkov angle",
	      60, 0.03, 0.05 );

  return 0;
}
