
// *****************************************************************************
//
// source:    AC_SVD_init.C  C&A routnie int of VDS 
//
// type:      source code
//
// created:   03 Nov 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_SVD_init()
//
// called by: AC_init()
//
// hints:     see $HBROOT/ARTE/dev/include/dq/DQ.h for COMP_XYZ and LVL_ABC
//
// changes:
// 03 Nov 1999 (AG)  further developments
// 19 Nov 1999 (AG)  cna -> ac (alca)
// 22 Nov 1999 (AG)  includes in alca
// 10 Dez 1999 (MBr) include of user part
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "dq/DQ.h"
#include "alca/AC_SVD.hh"

// Alignment:
#include "alca/AC_SVD_ALIGN5.h"

//
// program code
//
int
AC_SVD_init() {
  // show up
  cout << "AC_VDS_init()" << endl;

  // book histograms

  // Alignment:
  rhp_hbook2t(AC_ID(COMP_SVD,LVL_TST,101),"VDS Align Matrix",
	      ALIGN5_MAXP,-0.5,ALIGN5_MAXP-0.5, 
	      ALIGN5_MAXP,-0.5,ALIGN5_MAXP-0.5,RHP_DOUBLE);
  rhp_hbook1t(AC_ID(COMP_SVD,LVL_TST,102),"VDS Align Vector",
	      ALIGN5_MAXS,-0.5,ALIGN5_MAXP-0.5,RHP_DOUBLE);

  // Test of healthy helixes:
  rhp_hbook2( AC_ID(COMP_SVD,LVL_TST,201),"VDS hits/helix",
	      128,-0.5,127.5, 10,-0.5,9.5);


  return 0;
}




