
// *****************************************************************************
//
// source:    AC_evnt.C
//
// type:      source code
//
// created:   20 Oct 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_event()
//
// called by: acwrite()
//
// changes:
// 03 Nov 1999 (AG) add RICH
// 19 Nov 1999 (AG) cna -> ac (alca)
// 22 Nov 1999 (AG) includes in alca
// 12 Jan 2000 (AG) invoke gageEvnt();
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes

// includes
#include "arte/ArteProto.hh"
#include "dq/DQ.h"
#include "alca/AC_SVD.hh"
#include "alca/AC_RICH.hh"

// prototypes
extern "C" void cnakuip_();
int gageEvnt();

//
// initialize kuip commands
//
static class ACIniter
{
public:
  ACIniter() { atregkuip( cnakuip_, 1 ); } 
} _cnaIniter;

//
// program code
//
int
AC_evnt()
{
  // exec
  int rc = 0;
  if( AC_flag( COMP_SVD,  LVL_M_TST ) ) AC_SVD_evnt();
  if( AC_flag( COMP_RICH, LVL_M_TST ) ) AC_RICH_evnt();
  if( AC_flag( COMP_CORR, LVL_M_DEF ) ) rc = gageEvnt();

  return 0;
}
