
// *****************************************************************************
//
// source:    AC_init.C
//
// type:      source code
//
// created:   20 Oct 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_init()
//
// called by: acinit_()
//
// changes:
// 03 Nov 1999 (AG) add RICH
// 19 Nov 1999 (AG) cna -> ac (alca)
// 22 Nov 1999 (AG) includes in alca
// 24 Nov 1999 (AG) improve print-out
// 12 Jan 2000 (AG) invoke gageInit();
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes
#include "grr.h"

// Arte includes
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "alca/AC_SVD.hh"
#include "alca/AC_RICH.hh"

// prototypes
int gageInit();

// globals
int AC_SVD  = 0;
int AC_RICH = 0;

//
// program code
//
int
AC_init()
{
  // show up
  cout << "AC_init()" << endl;
  ARTE_error( GRR_SINFO, "AC_init()", 0 );

  // check subdetectors
  //cout << "AC_init(): AC_SVD()="  << AC_flag( COMP_SVD,  LVL_M_TST ) << endl;
  //cout << "AC_init(): AC_RICH()=" << AC_flag( COMP_RICH, LVL_M_TST ) << endl;
  
  // init
  int rc = 0;
  if( AC_flag( COMP_SVD,  LVL_M_TST ) ) AC_SVD_init();
  if( AC_flag( COMP_RICH, LVL_M_TST ) ) AC_RICH_init();
  if( AC_flag( COMP_CORR, LVL_M_DEF ) ) rc = gageInit();

  return 0;
}
