// ********************************************************************
//
//  Routine:      acReadGlobal
//  Author:       T.Oest
//
//  Description:  read global alignment constants from database
//                
//
//  Modification:
//   -- transformation routine for GEDE table called  
//                                                 16/09/99   T.Oest
//   -- access by key or data                      01/12/99   T.Oest
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>
#include <limits.h>
#include "arte/arte.hh"
#include "database/table.h"

#include "online/esp.h"


int  acReadGlobalByTime(int, char *);
int  acReadGlobalByKey(int, char *);
void acGlobalAlignmentForGEDE();
void ackuexec(char * KuipCommand);
 
static int first = 0;

//*****************************************************************
// function
//*****************************************************************

int acReadGlobal(int KTstatus) {

 int ACGAupdate = 0;

 int KeyStatus = KTstatus;
 if (KTstatus == 0) KeyStatus = 2;

//==================================================================
// no action for MC
//==================================================================

  if (ArteTable<MTRA>::size() > 0 ) return 0;

//==================================================================
// database server (default: /SETUP_ALIGN)
//                  can be changed by setting DB_GLOBAL_ALIGNMENT
//==================================================================

 char defaultserver[13];
 sprintf(defaultserver,"/SETUP_ALIGN");
 char * dbserver;

 if (getenv("DB_GLOBAL_ALIGNMENT") == NULL){
   dbserver = defaultserver;
 } else {
   dbserver = getenv("DB_GLOBAL_ALIGNMENT");
 };


//==================================================================
// get LUN number for database
//==================================================================
  char LunName[5] = {'D','B','G','A',0};
  char * KuipCommand =  (char*) malloc(max(128,
                                       int(24+strlen(dbserver))));

  if (first == 0){
    first = 1;
    sprintf (KuipCommand,"IOFILE %s %s",LunName,dbserver);
    ackuexec(KuipCommand);
  };
 

//==================================================================
// acces by key table
//==================================================================

 if (KeyStatus >= 1) ACGAupdate = acReadGlobalByKey(KeyStatus, dbserver);


//==================================================================
// acces by date if KeySstatus < 1 or access by key not sucessfull
//==================================================================

 if (KeyStatus < 1 || ACGAupdate < 0) 
    ACGAupdate = acReadGlobalByTime(KeyStatus, dbserver);

//==================================================================
// check if ACGA table exist
//==================================================================

 if (ArteTable<ACGA>::size() == 0) return -3;

//==================================================================
// change GEDE table:
//         acGlobalAlignmentForGEDE() will just return since CATS
//         does not work with global GEDE tables
//==================================================================

 if (ACGAupdate > 0) acGlobalAlignmentForGEDE();


 return 0;
}
