#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteUtil.h"
//#include "auto/auto.hh"

extern "C" {
extern void chttoh_ (char &input, char &output, const int &nwords);

void dfatt (char &name, int type, int dim, int key, int ilow, int iupp,
            float flow, float fupp, float accu) {
  for (int l = 0; l < dim; l++) {
    MEMA mema;
    chttoh_ (name, mema.name[0], namelen);
    mema.type = type;
    mema.rela = 0;
    mema.relt = 0;
    mema.relp = 0;
    mema.key  = key;
    mema.ilow = ilow;
    mema.iupp = iupp;
    mema.flow = flow;
    mema.fupp = fupp;
    mema.accu = accu;
    mema.imin = AR_ILARGEST;
    mema.imax = AR_ISMALLEST;
    mema.fmin = -AR_FLARGEST;
    mema.fmax = AR_FLARGEST;
    ArtePointer<MEMA>::append(mema);
  }
}

void dfattb (char &name, int nbits) {
  dfatt (name, 6, 1, 0, nbits, 0, 0., 0., 0.);
}

void dfat0b (char &name) {
  dfatt (name, 6, 1, 0, 32, 0, 0., 0., 0.);
}

void dfaltb (char &name, int nbits) {
  dfatt (name, 6, 1, 1, nbits, 0, 0., 0., 0.);
}

void dfal0b (char &name) {
  dfatt (name, 6, 1, 1, 32, 0, 0., 0., 0.);
}

void dfattc (char &name, int dim) {
  dfatt (name, 11, dim, 0, 0, 0, 0., 0., 0.);
}

void dfaltc (char &name, int dim) {
  dfatt (name, 11, dim, 1, 0, 0, 0., 0., 0.);
}

void dfattf (char &name, float flow, float fupp, float accu) {
  dfatt (name, 7, 1, 0, 0, 0, flow, fupp, accu);
}

void dfat0f (char &name) {
  dfatt (name, 7, 1, 0, 0, 0, -AR_FLARGEST, AR_FLARGEST, 0.);
}

void dfaltf (char &name, float flow, float fupp, float accu) {
  dfatt (name, 7, 1, 1, 0, 0, flow, fupp, accu);
}

void dfal0f (char &name) {
  dfatt (name, 7, 1, 1, 0, 0, -AR_FLARGEST, AR_FLARGEST, 0.);
}

void dfatth (char &name, int dim) {
  dfatt (name, 8, dim, 0, 0, 0, 0., 0., 0.);
}

void dfalth (char &name, int dim) {
  dfatt (name, 8, dim, 1, 0, 0, 0., 0., 0.);
}

void dfatti (char &name, int ilow, int iupp) {
  dfatt (name, 5, 1, 0, ilow, iupp, 0., 0., 0.);
}

void dfat0i (char &name) {
  dfatt (name, 5, 1, 0, AR_ISMALLEST, AR_ILARGEST, 0., 0., 0.);
}

void dfalti (char &name, int ilow, int iupp) {
  dfatt (name, 5, 1, 1, ilow, iupp, 0., 0., 0.);
}

void dfal0i (char &name) {
  dfatt (name, 5, 1, 1, AR_ISMALLEST, AR_ILARGEST, 0., 0., 0.);
}

void dfattr (char &name) {
  dfatt (name, 0, 1, 0, 0, 0, 0., 0., 0.);
}

void dfaltr (char &name) {
  dfatt (name, 0, 1, 1, 0, 0, 0., 0., 0.);
}

void dfatts (char &name, int ilow, int iupp) {
  dfatt (name, 9, 1, 0, ilow, iupp, 0., 0., 0.);
}

void dfat0s (char &name) {
  dfatt (name, 9, 1, 0, AR_SSMALLEST, AR_SLARGEST, 0., 0., 0.);
}

void dfalts (char &name, int ilow, int iupp) {
  dfatt (name, 9, 1, 1, ilow, iupp, 0., 0., 0.);
}

void dfal0s (char &name) {
  dfatt (name, 9, 1, 1, AR_SSMALLEST, AR_SLARGEST, 0., 0., 0.);
}

void dfattu (char &name, int nbits) {
  dfatt (name, 10, 1, 0, nbits, 0, 0., 0., 0.);
}

void dfat0u (char &name) {
  dfatt (name, 10, 1, 0, 16, 0, 0., 0., 0.);
}

void dfaltu (char &name, int nbits) {
  dfatt (name, 10, 1, 1, nbits, 0, 0., 0., 0.);
}

void dfal0u (char &name) {
  dfatt (name, 10, 1, 1, 16, 0, 0., 0., 0.);
}
void dfattp (char &name, int link) {
    MEMA mema;
    chttoh_ (name, mema.name[0], namelen);
    mema.type = 5;
    mema.rela = 0;
    mema.relt = (int) ((unsigned) link -
                       (unsigned) &artelink_.narlnk) / 4;
    mema.relp = 0;
    mema.key  = 0;
    mema.ilow = 0;
    mema.iupp = AR_ILARGEST;
    mema.flow = 0.;
    mema.fupp = 0.;
    mema.accu = 0.;
    mema.imin = AR_ILARGEST;
    mema.imax = AR_ISMALLEST;
    mema.fmin = -AR_FLARGEST;
    mema.fmax = AR_FLARGEST;
    ArtePointer<MEMA>::append(mema);
}
}
