/************************************************************************
*
* $Source: /afs/desy.de/group/hera-b/repository/ARTE/arte/dftabl.c,v $
* $Revision: 1.1 $
* $Author: natasha $
* $Date: 1998/10/27 15:02:35 $
*
* Created: July 7, 1997 by Hartwig Albrecht
*
* Called from: usautt
*
* Arguments:
* *link     pointer to Zebra link
* *name     name
* div       Zebra division (1: const; 2: event)
* col       number of columns/row
* outcol    number of columns on output files
* extension number of reserved rows when extending the table
* *link_sup pointer to a Zebra link of the superior table
* *iofiles  list of input / output files
*
**********************************************************************/

#include <stdio.h>
#include "arte/Arte.h"
#include "arte/ArteFlag.h"
#include "auto/MEMO.h"
#include "auto/MEMA.h"
#include "arte/ZMMCOM.h"

extern void chttoh_ (char *input, char *output, int *nwords);
extern void dffile_ (int  *link, char *iofiles);

void dftabl (int *link, char *name, int div, int col,
	     int outcol, int extension, char *iofiles){

  int i, j = namelen;

  i = ((unsigned) link - (unsigned) &artelink_.narlnk) / 4;
  zmmcom_.lmmtab = i;

  chttoh_ (name, &MEMO(i).name[0], &j);
  MEMO(i).div = (div == 1) ? gcbank_.ixcons : gcbank_.ixevnt;
  MEMO(i).col = col;
  MEMO(i).ocol = outcol;
  MEMO(i).ext = extension;
  MEMO(i).mema = NMEMA() + 1;
  /*  This is a call to a Fortran routine.
      Should be replaced by the corresponding code in C ! H.A.*/
  dffile_ (&i, iofiles);
}
