*-- Author :    Hartwig Albrecht   03/03/95

      SUBROUTINE IOCONC (LUN, CNAM, CZEB, OUTM)

************************************************************************
*
* Description: Concatenate data set CNAM to logical unit LUN.
*              LUN > 0 : append at the end of the concatenation chain
*              LUN < 0 : insert immediately after LUN
*              Does NOT perform any OPEN.
*
* Called from: IO routines
*
* External references: none
*
* Argument in/out description
*   LUN    in     logical unit number (may be < 0; see above)
*   CNAM   in     data set name or comment
*   CZEB   in     IO options for Zebra
*   OUTM   in     maximum number of Mbytes on output files
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"

      INTEGER L, LUN
      REAL OUTM
      CHARACTER CNAM*(*), CZEB*(*), CC*120

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      L = ABS(LUN)
      IF (L .LE. 0 .OR. L .GE. 100)  THEN
        CALL MEERRC (55,
     +    'IO: unit number not in the range 1 ... 99')
        GO TO 90
      END IF

      IF (IMEIO_FLAG(L) .LE. 0)  THEN
        IQ(IQMEIO_FLAG(L)) = 1
        CALL CHCTOH (CNAM, IQ(HQMEIO_NAME(1,L)), 30)
        CALL CHCTOH (CZEB, IQ(HQMEIO_ZOPTION(1,L)), 2)
        Q(QMEIO_MAXOUT(L)) = OUTM
        GO TO 90
      END IF

      IF (LUN .GT. 0)  THEN
 10     CALL CHHTOC (IQ(HQMEIO_NAME(1,L)), CC)
        IF (CC .EQ. CNAM)  THEN
          CC = 'IO_CONC: file'
          CALL CHAPBC (CC, CNAM)
          CALL CHAPBC (CC, 'previously concatenated to unit')
          CALL CHAPBI (CC, ABS(LUN))
          CALL MEWARC (8735274, CC)
        END IF
        IF (IMEIO_CONCAT(L) .EQ. 0)  GO TO 20
        L = IMEIO_CONCAT(L)
        GO TO 10
      END IF

 20   CALL MMBOOK (JMEIO, 1)
      IQ(IQMEIO_CONCAT_L()) = IQ(IQMEIO_CONCAT(L))
      IQ(IQMEIO_CONCAT(L)) = NMEIO()
      IQ(IQMEIO_FLAG_L()) = 1
      CALL CHCTOH (CNAM, IQ(HQMEIO_NAME_L(1)), 30)
      CALL CHCTOH (CZEB, IQ(HQMEIO_ZOPTION_L(1)), 2)
      Q(QMEIO_MAXOUT(L)) = OUTM

 90   END

************************************************************************
* End of IOCONC
************************************************************************
