*-- Author :    Hartwig Albrecht   11/07/95

      SUBROUTINE MMIREL (JL)

************************************************************************
*
* Description: invert a relation
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   JL     in     link to the relation bank
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL(1), IL, IPOS, JSUP, K1, K2, KR, KM, LOCF, MZBUF(5)
      CHARACTER CNAME*4
      DATA MZBUF /5 * 0/

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      JSUP(I_R) = JLINK(IMEMO_SUP(I_R,IL))
      IPOS(I_R) = IMEMO_POS(I_R,IL)

      IL = LOCF (JL) - LARLN1

C check if JL is a correct Zebra link

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  GO TO 580

C check if JL refers to a relation

      IF (IMEMO_FLAG(IL) .LE. 0 .OR. IMEMO_FLAG(IL) .GT. 4)  GO TO 570

      IF (JSUP(1) .EQ. 0 .OR. JSUP(2) .EQ. 0)  THEN
        IF (JL(1) .NE. 0)  THEN
            IF (N_U(JL(1)) .NE. 0)  THEN
            CALL CHHTOC (IQ(HQMEMO_NAME(1, IL)), CNAME)
            CALL MEERRC (654374,
     +        'MMIREL: relation '//CNAME//' points to empty tables')
          END IF
        END IF
        GO TO 900
      END IF

C Check that relations are properly cleaned

      DO K1 = 1, N_U(JSUP(1))
        IF (IQ(L_A(IPOS(1),K1,JSUP(1))) .NE. 0)  THEN
          IF (IQ(L_A(IPOS(1),K1,JSUP(1))) .NE. K1)  GO TO 560
          CALL CHHTOC (IQ(HQMEMO_NAME(1, IL)), CNAME)
          CALL MEMESC (923445, 20, ILARGEST,
     +      'MMIREL: relation '//CNAME//' has already been set')
          IQ(L_A(IPOS(1),K1,JSUP(1))) = 0
        END IF
      END DO

      GO TO (100,200,300,400), IMEMO_FLAG(IL)

 100  DO 110 K2 = 1, N_U(JSUP(2))
        K1 = I_V(IPOS(2),K2,JSUP(2))
        IF (K1 .EQ. 0)  GO TO 110
        IF (K1 .LT. 0 .OR. K1 .GT. N_U(JSUP(1)))  GO TO 530
        IQ(L_A(IPOS(1),K1,JSUP(1))) = K2
 110  CONTINUE
      GO TO 900

 200  IF (JL(1) .EQ. 0)  THEN
        MZBUF(1) = HMEMO_NAME(1,IL)
        MZBUF(4) = 2 +  2 * (IMEMO_EXT(IL))
        MZBUF(5) = IMEMO_FMT(IL)
        CALL MZLIFT (IMEMO_DIV(IL), JL, 0, 2, MZBUF, 0)
        IQ(JL(1)+1) = IMEMO_COL(IL)
        IQ(JL(1)+2) = 0
        IQ(IQMEMO_BOOK(IL)) = IQ(IQMEMO_BOOK(IL)) + 1
        IQ(IQMEMO_EXTN(IL)) = IQ(IQMEMO_EXTN(IL)) + 1

      ELSE
        IF (IQ(JL(1)+1) .NE. 2)  GO TO 540
        IF (IQ(JL(1)+2) .NE. 0)  GO TO 550

      END IF

      DO 210 K2 = 1, N_U(JSUP(2))
        K1 = I_V(IPOS(2),K2,JSUP(2))
        IF (K1 .EQ. 0)  GO TO 210
        IF (K1 .LT. 0 .OR. K1 .GT. N_U(JSUP(1)))  GO TO 530
        IF (N_F(JL(1)) .EQ. 0)  THEN
          CALL MZPUSH (IMEMO_DIV(IL), JL, 0,
     +      2 * (IMEMO_EXT(IL)), ' ')
          IQ(IQMEMO_EXTN(IL)) = IQ(IQMEMO_EXTN(IL)) + 1
       END IF
        IQ(JL(1)+2) = IQ(JL(1)+2) + 1
        IQ(L_L(1,JL(1))) = K2
        IQ(L_L(2,JL(1))) = I_V(IPOS(1),K1,JSUP(1))
        IQ(L_A(IPOS(1),K1,JSUP(1))) = N_U(JL(1))
 210  CONTINUE
      GO TO 900

 300  CALL CHHTOC (IQ(HQMEMO_NAME(1, IL)), CNAME)
      CALL MEERRC (834244,
     +   'MMIREL: relation '//cname//': many to one is not supported')
      GO TO 900

 400  IF (JL(1) .EQ. 0)  GO TO 900
      KM = 0
      DO 420 K2 = 1, N_U(JSUP(2))
        KR = I_V(IPOS(2),K2,JSUP(2))
 410    IF (KR .EQ. 0)  GO TO 420
        IF (KR .LT. 0 .OR. KR .GT. N_U(JL(1)))  GO TO 530
        K1 = I_V(1,KR,JL(1))
        IF (K1 .LE. 0 .OR. K1 .GT. N_U(JSUP(1)))  GO TO 530
        KM = KM + 1
        IQ(L_A(3,KM,JL(1))) = K2
        IQ(L_A(4,KM,JL(1))) = I_V(IPOS(1),K1,JSUP(1))
        IQ(L_A(IPOS(1),K1,JSUP(1))) = KM
        KR = I_V(2,KR,JL(1))
        GO TO 410
 420  CONTINUE

      GO TO 900

 530  CALL CHHTOC (IQ(HQMEMO_NAME(1, IL)), CNAME)
      CALL MEERRC (863445,
     +   'MMIREL: relation '//cname//' points to an invalid row number')
      GO TO 900

 540  CALL CHHTOC (IQ(HQMEMO_NAME(1, IL)), CNAME)
      CALL MEERRC (534634,
     +   'MMIREL: relation '//cname//' has a wrong number of columns')
      GO TO 900

 550  CALL CHHTOC (IQ(HQMEMO_NAME(1, IL)), CNAME)
      CALL MEERRC (534634,
     +   'MMIREL: relation '//cname//' has already been set')
      GO TO 900

 560  CALL CHHTOC (IQ(HQMEMO_NAME(1, IL)), CNAME)
      CALL MEERRC (634534,
     +   'MMIREL: relation '//cname//': one-to-... already established')
      GO TO 900

 570  CALL MEERRC (8234645,
     +   'MMIREL: link JL is not a relation')
      GO TO 900

 580  CALL MEERRC (945645,
     +  'MMIREL: link JL not inside link area')

 900  END

************************************************************************
* End of MMIREL
************************************************************************
