//                              -*- Mode: C++ -*-
//:ELNearHitCells.hh
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 27/5/97
// Last Update ........
//
//

#ifndef ELNEARHITCELLS_HH_
#define ELNEARHITCELLS_HH_

class EMHitCell;
class EMClusterTree;
#include "care/ECALtypes.hh"
/**
class  ELNearHitCells.
  Get the list of nearby clusterized cells
  and provide access to the list
*/

class ELNearHitCells {
public:
  //--
  ///  constructor
  ELNearHitCells();
  //--
  ///  destructor
  ~ELNearHitCells();

  /**@name Beheavioral methods */
  //@{ 
  //--
  ///  Get the neighbours of a given cell
  void of(const EMHitCell* cell, const EMClusterTree & tree);
  //--
  ///  Get neighbouring cells of a given cell
  void of(CellIdx_t cell, const EMClusterTree & tree);
  //@}
 
  /**@name Iterator methods */
  //@{ 
  //--
  //  start an iteration 
  inline void begin();
  //--
  //  access member
  inline bool more() const;
  //--
  //  consider next cell
  inline void next();
  //--
  //  get the current cell
  inline EMHitCell* operator*() const;
  //--
  //  get the number of neighbours
  inline unsigned int  howMany() const;
  //@}

protected:
  //--
  ///  Number of stored neighbours
  unsigned int numNeib;
  //--
  ///  Array containing the cells
  EMHitCell*  neibCells[20];
  //--
  ///  pointer to current cell
  unsigned int curr;
};

#include "care/ELNearHitCells.icc"
#endif // ELNEARHITCELLS_HH_
