
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 05 Nov 1999 (AG) improve histogramming
// 19 Nov 1999 (AG) show up
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"

// prototypes
void ECAL_rec_book( int tcode );

//
// function code
//
int
DQ_ECAL_rec_init()
{
  cout << "DQ_ECAL_rec_init()" << endl;
  ECAL_rec_book( 0 );
  ECAL_rec_book( 9 );

  return 0;
}

//
// function code
//
void
ECAL_rec_book( int tcode )
{
  int ad = tcode * 100;

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1001+ad),"ECAL: Mass of Jpsi",50,2,5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1002+ad),"ECAL: Mass of Pi0",50,0,0.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1003+ad),"ECAL: Mass of Pi0 in inner part",50,0,0.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1004+ad),"ECAL: Mass of Pi0 in middle part",50,0,0.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1005+ad),"ECAL: E",80,0,40);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1006+ad),"ECAL: Et",80,0,2);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1007+ad),"ECAL: Maximum Et in event",100,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1008+ad),"ECAL: Second highest Et in event",100,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1009+ad),"ECAL: Maximum mass in event",50,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1010+ad),"ECAL: Maximum mass with SLT cuts",50,0,10);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,1011+ad),"ECAL: Third highest Et in event",100,0,10);

  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,2001+ad),"ECAL: Position of cluster",
	     50,-223,223,50,-223,223);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,2002+ad),"ECAL: Energy density of clusters",
	     50,-223,223,50,-223,223);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_REC,2010+ad),"ECAL: Total energy deposited in clusters in event",
	     150,0,1500);

  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,3000+ad),"ECAL: Occupancy of highest pt-cluster", 
	     50,-223,223,50,-223,223);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_REC,3001+ad),"ECAL: Occupancy of highest pt-cluster", 
	     50,-223,223,50,-223,223);
}
