
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
// changes:
// 07 Sep 1999 (AG) fill processing time histo
// 09 Sep 1999 (AG) polishing
// 21 Oct 1999 (AG) polishing
// 27 Oct 1999 (AG) use defines from DQ.h
// 29 Oct 1999 (AG) redefine histogram IDs
//  1 Nov 1999 (AG) get rid of dq_hid.h
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_FARM.h"

//
// function code
//
int
DQ_FARM_hit_evnt()
{
  //====================================================================
  //       Trigger Code
  //====================================================================
  
  float FCS_tcode = faDDAQFCS_tcode();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_HIT, 1 ), FCS_tcode, 1 );
  
  //====================================================================
  //       Target Rate
  //====================================================================
  
  float ia = faDTARia();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_HIT, 2 ), ia, 1 ); // [MHz]
  
  //====================================================================
  //   get information about slp/farm-nodes
  //====================================================================
  
  int slp_node = faDDAQslp_node();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_HIT, 3 ), float( slp_node ),  1 );

  int farm_node = faDDAQfarm_node();
  rhp_hf1( DQ_ID( COMP_FARM, LVL_HIT, 4 ), float( farm_node - 50 ), 1 );
  
  //====================================================================
  //   processing time
  //====================================================================

  // filled at the end of usevnt()!
  //rhp_hf1( DQ_ID( COMP_FARM, LVL_HIT, 5 ), cpuTime, 1 );
  
  //====================================================================
  //   raw event size
  //====================================================================  
  
  int length = faDEVTlength(); // [B]
  rhp_hf1( DQ_ID( COMP_FARM, LVL_HIT, 6 ), float( length )/1000, 1 ); // [kB]

  //====================================================================
  //   get time from DDAQ table
  //====================================================================

  //static int datimeold = 0;
  //int datime           = faDDAQevent_time();
  //int delta            = datime - datimeold;
  //rhp_hf1( DQ_ID( COMP_FARM, LVL_HIT, 7 ),float(delta ), 1 );
  //datimeold = datime;
    
  return 0; // return error code (0 = okay)
}
