
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
// changes:
// 07 Sep 1999 (AG) add processing time histo
// 09 Sep 1999 (AG) polishing
// 04 Oct 1999 (AG) polishing
// 07 Oct 1999 (AG) decrease range for processing time
// 21 Oct 1999 (AG) polishing
// 27 Oct 1999 (AG) use defines from DQ.h
// 29 Oct 1999 (AG) redefine histogram IDs
//  1 Nov 1999 (AG) get rid of dq_hid.h
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_FARM.h"

//
// function code
//
int
DQ_FARM_hit_init()
{
  cout << "DQ_FARM_hit_init()" << endl;
  
  // book histograms
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 1 ),
	      "FARM: Trigger code", 15, -0.5, 14.5 );

  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 2 ),
	      "FARM: Target Rate", 50, 0, 50. ); // [MHz]

  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 3 ),
	      "FARM: SLP_node", 200, -0.5, 199.5 );

  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 4 ),
	      "FARM: 4LT_node", 100, -0.5, 99.5 );

  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 5 ),
	      "FARM: Processing time", 100, 0.0, 2.0 ); // [sec]

  rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 6 ),
	      "FARM: Raw event size", 40, 0.0, 200.0 ); // [kB]

  //rhp_hbook1( DQ_ID( COMP_FARM, LVL_HIT, 7 ),
  //      "FARM: Time difference between two events", 40, -10000., 10000. ); // [sec]
  
  return 0; // return error code (0 = okay)
}
