
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
// A. Gellrich
//
// Filling of histograms
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
//         histogram id: 1 - 65535
//
// changes:
// 27 Oct 1999 (AG) use defines in DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

//
// function code
//
int DQ_MUON_hit_evnt()
{
  float NrMUONHits=0;
  float NrMUONTubeHits=0;
  float NrMUONPadHits=0;
  float NrMUONPixelHits=0;
  float NrMUONHitsMt1=0;
  float NrMUONHitsMt2=0;
  float NrMUONHitsMt3=0;
  float NrMUONHitsMt4=0;
  float NrMUONHitsMp3=0;
  float NrMUONHitsMp4=0;
  float NrMUONHitsMx1=0;
  float NrMUONHitsMx2=0;
  float NrMUONHitsMx3=0;
  float NrMUONHitsMx4=0;

  for (ArteTableIterator<HITB> hitb; hitb.valid(); hitb.next() ) {

    ArtePointer<GEDE> gede(hitb->gede); 

    if (gede->cmp==8) { // tube and pad chambers
         
      if (strncmp(gede->gesl->name,"MUD1",4)==0) {  // MU1 tube chambers
	NrMUONHitsMt1++;
	//  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf0001),gede.index(),1);
              
	if (gede->symx>200) { // upper part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10011),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10013),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10015),hitb->x,1);}
	} else { // lower part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10012),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10014),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10016),hitb->x,1);}
	}
      }

      if (strncmp(gede->gesl->name,"MUD2",4)==0) {  // MU2 tube chambers
	NrMUONHitsMt2++;
	// rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf0002),gede.index(),1);

	if (gede->symx>200) { // upper part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10021),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10023),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10025),hitb->x,1);}

	} else { // lower part

	  if (gede->lay==1)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10022),hitb->x,1);}
	  if (gede->lay==2)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10024),hitb->x,1);}
	  if (gede->lay==3)
	    {rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10026),hitb->x,1);}
	}
      }

      if (strncmp(gede->gesl->name,"MUD3",4)==0){ 
	// rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf0003),gede.index(),1);
 
	if (fabs(hitb->y)<0.000001) { // tube, no pad
	  NrMUONHitsMt3++;

	  if (gede->symx>200) {// upper part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10031),hitb->x,1);
	  } else { // lower part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10032),hitb->x,1);
	  }

	} else { // pad
	  NrMUONHitsMp3++;
	  rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x20003),hitb->x, hitb->y,1);
	}
      }

      if (strncmp(gede->gesl->name,"MUD4",4)==0){ 
	// rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf0004),gede.index(),1);
	if (fabs(hitb->y)<0.000001) { // tube, no pad
	  NrMUONHitsMt4++;

	  if (gede->symx>200) { // upper part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10041),hitb->x,1);
	  } else { // lower part
	    rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0x10042),hitb->x,1);
	  }
	} else { // pad
	  NrMUONHitsMp4++;
	  rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x20004),hitb->x, hitb->y,1);
	}
      }

    }     //  End of Pad and Tube Loop

    if (gede->cmp==9) { // pixel chambers

      //  if (strncmp(gede->gesl->name,"MXD",3)==0)
      //  {
      //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xf0030),
      //  gede.index()-gede->gesl->fpl + 6*(gede->gesl.index()-35),1);
      //  }

      if (strncmp(gede->gesl->name,"MXD1",4)==0) { // MU1 pixel
	NrMUONHitsMx1++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x30001),hitb->x, hitb->y,1);
      }
      if (strncmp(gede->gesl->name,"MXD2",4)==0) { // MU2 pixel
	NrMUONHitsMx2++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x30002),hitb->x, hitb->y,1);
      }
      if (strncmp(gede->gesl->name,"MXD3",4)==0) { // MU3 pixel
	NrMUONHitsMx3++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x30003),hitb->x, hitb->y,1);
      }
      if (strncmp(gede->gesl->name,"MXD4",4)==0) { // MU4 pixel
	NrMUONHitsMx4++;
	rhp_hfill(DQ_ID(COMP_MUON,LVL_HIT,0x30004),hitb->x, hitb->y,1);
      }

    }    //  End of Pixel Loop

  }      //  End of HitB Loop

  
  //  NrMUONTubeHits = NrMUONHitsMt1 + NrMUONHitsMt2 + NrMUONHitsMt3 + NrMUONHitsMt4;
  //  NrMUONPadHits = NrMUONHitsMp3 + NrMUONHitsMp4;
  //  NrMUONPixelHits = NrMUONHitsMx1 + NrMUONHitsMx2 + NrMUONHitsMx3 + NrMUONHitsMx4;
  //  NrMUONHits = NrMUONTubeHits + NrMUONPadHits + NrMUONPixelHits;

  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa0001),NrMUONHitsMt1,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa0002),NrMUONHitsMt2,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa0003),NrMUONHitsMt3,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xa0004),NrMUONHitsMt4,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xb0003),NrMUONHitsMp3,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xb0004),NrMUONHitsMp4,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc0001),NrMUONHitsMx1,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc0002),NrMUONHitsMx2,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc0003),NrMUONHitsMx3,1);
  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xc0004),NrMUONHitsMx4,1);

  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd0001),NrMUONHits,1);
  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd0002),NrMUONTubeHits,1);
  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd0003),NrMUONPadHits,1);
  //  rhp_hf1(DQ_ID(COMP_MUON,LVL_HIT,0xd0004),NrMUONPixelHits,1);

  return 0; // return error code (0 = okay)
}
