
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
// A. Gellrich
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//         histogram id: 1 - 65535
//
// changes:
// 22 Oct 1999 (AG) removed print-out "here is histogram ..."
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

//
// function code
//
int
DQ_MUON_hit_init()
{
  cout << "DQ_MUON_hit_init()" << endl;

  //======================================================================
  //          MUON stuff
  //======================================================================
  
  //  for(ArteTableIterator<GESL> gesl;gesl.valid();gesl.next()){
  //
  //   if(strncmp(gesl->name,"MUD1",4)==0)
  //     {
  //      rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xf0001),"MUON: hits per gede in MUD1",
  //                  gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
	  //AG cout << "DQ_MUON_hit_init(): here is the histogram: "
	  //AG      << DQ_ID(COMP_MUON,LVL_HIT,810100) << endl;
  //     }
  //   if(strncmp(gesl->name,"MUD2",4)==0)
  //     {
  //      rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xf0002),"MUON: hits per gede in MUD2",
  //                 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
  //     }
  //    if(strncmp(gesl->name,"MUD3",4)==0)
  //     {
  //      rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xf0003),"MUON: hits per gede in MUD3",
  //                 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
  //     }
  //    if(strncmp(gesl->name,"MUD4",4)==0)
  //     {
  //      rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xf0004),"MUON: hits per gede in MUD4",
  //                 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
  //     }
  // }

  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xf0030),"MUON: hits per gede in Pixel chambers",25,-0.5,24.5);

  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa0001),"MUON: Nr of hits in Mt1 in event",50,0,200);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa0002),"MUON: Nr of hits in Mt2 in event",50,0,200);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa0003),"MUON: Nr of hits in Mt3 in event",50,0,200);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa0004),"MUON: Nr of hits in Mt4 in event",50,0,200);

  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xb0003),"MUON: Nr of hits in Mp3 in event",50,0,100);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xb0004),"MUON: Nr of hits in Mp4 in event",50,0,100);

  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc0001),"MUON: Nr of hits in Mx1 in event",50,0,300);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc0002),"MUON: Nr of hits in Mx2 in event",50,0,300);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc0003),"MUON: Nr of hits in Mx3 in event",50,0,300);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc0004),"MUON: Nr of hits in Mx4 in event",50,0,300);

  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd0001),"MUON: Nr of hits in event",50,0,1500);
  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd0002),"MUON: Nr of Tube hits in event",50,0,800);
  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd0003),"MUON: Nr of Pad hits in event",50,0,200);
  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd0004),"MUON: Nr of Pixel hits in event",50,0,800);
  
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10011),"MUON: Occupancy of Mt1.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10012),"MUON: Occupancy of Mt1.2",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10013),"MUON: Occupancy of Mt1.3",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10014),"MUON: Occupancy of Mt1.4",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10015),"MUON: Occupancy of Mt1.5",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10016),"MUON: Occupancy of Mt1.6",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10021),"MUON: Occupancy of Mt2.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10022),"MUON: Occupancy of Mt2.2",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10023),"MUON: Occupancy of Mt2.3",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10024),"MUON: Occupancy of Mt2.4",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10025),"MUON: Occupancy of Mt2.5",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10026),"MUON: Occupancy of Mt2.6",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10031),"MUON: Occupancy of Mt3.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10032),"MUON: Occupancy of Mt3.2",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10041),"MUON: Occupancy of Mt4.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x10042),"MUON: Occupancy of Mt4.2",1088,-444.21,444.21);

  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x20003),"MUON: Occupancy of Mp3",66,-445,445,60,-320,320);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x20004),"MUON: Occupancy of Mp4",66,-445,445,58,-320,320);

  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x30001),"MUON: Occupancy of Mx1",46,-39.6,39.6,60,-29.7,29.7);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x30002),"MUON: Occupancy of Mx2",46,-39.6,39.6,60,-29.7,29.7);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x30003),"MUON: Occupancy of Mx3",90,-39.6,39.6,16,-29.7,29.7);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x30004),"MUON: Occupancy of Mx4",96,-45.12,45.12,18,-32.9,32.9);

  return 0; // return error code (0 = okay)
}
