// ------------------------------------------------------
// ---
// ---  created: Aug 99 
// ---  author:  Denis Dujmic
// ---
// ---
// ---  RICH FED Occupancy Quality Check
// ---
// ---
// changes:
// 28 Oct 1999 (AG) use utility function for ia rate
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 16 Dec 1999 (RP) histograms for fed channels and ph.det.
// ------------------------------------------------------
#include "dq/DQ.h"
#include "rhp.h"
#include "rich/rich.h"
#include "farm/farm.hh"

//AG float get_interaction_rate(EVENT_HDR *event);

void DQ_RICH_publish() {

 const int MAXHIST=100;
 static int nhist;
 static int hist_ids[MAXHIST];
 rhp_hid(0, hist_ids, MAXHIST, &nhist);
 printf("dmon_hpublish> Histogram list for publishing contains %d Ids:\n", nhist); 
 for (int i=0; i<nhist; i++) printf("%d\n",hist_ids[i]); 

 printf("...publishing...\n");
 int cr;
 printf("%d %d\n",GRR_OK,GRR_INVALID);
 if ((cr=rhp_publish(DQ_ID(COMP_RICH,LVL_RAW,100)))) printf("dmon_hpublish ***Error %d publishing Histo %d\n",cr,DQ_ID(COMP_RICH,LVL_RAW,100) );
 if ((cr=rhp_publish(DQ_ID(COMP_RICH,LVL_RAW,101)))) printf("dmon_hpublish ***Error %d publishing Histo %d\n",cr,DQ_ID(COMP_RICH,LVL_RAW,101) );
 if ((cr=rhp_publish(DQ_ID(COMP_RICH,LVL_RAW,102)))) printf("dmon_hpublish ***Error %d publishing Histo %d\n",cr,DQ_ID(COMP_RICH,LVL_RAW,102) );
 if ((cr=rhp_publish(DQ_ID(COMP_RICH,LVL_RAW,103)))) printf("dmon_hpublish ***Error %d publishing Histo %d\n",cr,DQ_ID(COMP_RICH,LVL_RAW,103) );
 if ((cr=rhp_publish(DQ_ID(COMP_RICH,LVL_RAW,104)))) printf("dmon_hpublish ***Error %d publishing Histo %d\n",cr,DQ_ID(COMP_RICH,LVL_RAW,104) );
 if ((cr=rhp_publish(DQ_ID(COMP_RICH,LVL_RAW,105)))) printf("dmon_hpublish ***Error %d publishing Histo %d\n",cr,DQ_ID(COMP_RICH,LVL_RAW,105) );

}

extern float *fed_rich_buf;
int DQ_RICH_raw_evnt(EVENT_HDR *event){

  // printf("DQ_RICH_raw_evnt\n");

  // --  used histograms
  unsigned int rich_fed_histo_id=DQ_ID(COMP_RICH, LVL_RAW,100);
  unsigned int rich_fed_refer_id=DQ_ID(COMP_RICH, LVL_RAW,101);
  unsigned int rich_fed_ratio_id=DQ_ID(COMP_RICH, LVL_RAW,102);
  unsigned int rich_allfed_histo_id=DQ_ID(COMP_RICH, LVL_RAW,103);
  unsigned int phdet[2]={ DQ_ID(COMP_RICH, LVL_RAW,104),
			  DQ_ID(COMP_RICH, LVL_RAW,105) };
  // -- my event count
  static unsigned int event_count=0;
  event_count++;

  static int nfed=RICH_DAQ->NumFED();
  static float *fed_count=0;
  static float *fed_ratio=0;
  static float *fed_refer=0;  
  if (!fed_count) {
    fed_count=new float[nfed];
    fed_ratio=new float[nfed];
    fed_refer=new float[nfed];
  }

  // -- interaction rate
  //AG float ia=1/get_interaction_rate(event);

  //float ia=1; // for stand-alone test run
  float ia = 1 / faDTARia(); // farm utility

  // --- update fed occupancy per event

  if (!RICH_DAQ->NextEvent(event)) return 1;
  for (int i=0; RICH_DAQ->HitChannelExist(i); i++)  {
    // fed channels
    int id=RICH_DAQ->fedid()    <<10+
           RICH_DAQ->daughter() <<8 +
           RICH_DAQ->connector()<<4 + 
           RICH_DAQ->channel();
    fed_rich_buf[id]++;
    // photon detector
    int sm   =RICH_DAQ->sm();
    int row  =RICH_DAQ->row();
    int col  =RICH_DAQ->col();
    int ch  =RICH_DAQ->pm_channel();
    int type =RICH_DAQ->pm_numchannel();
    int hid = 1;
    if (sm >6) {
      hid=0;
      sm=13-sm;
      col=11-col;
      row=31-row;        
    }
    sm--;
    if (type==16) type=0; else type=1;
    int x0=col*4+sm*48;
    int y0=row*4;
    if (type) {
      x0+=3-ch%4;
      y0+=3-ch/4;
    } else {
      x0+=(1-ch%2)*2;
      y0+=(1-ch/2)*2;    
    }
    for (int k=0;k<(type+1);k++) {
      for (int l=0;l<(type+1);l++) {
	rhp_hfill(phdet[hid],x0+k,y0+l,1);
      }
    }

    rhp_hf1(rich_fed_histo_id,RICH_DAQ->fedid(),ia);
  }
  rhp_hpak(rich_allfed_histo_id,fed_rich_buf);
  //  printf("Number of hit channels=%d\n",RICH_DAQ->NumHitChannel()); 

  if (event_count%100) return 0;

  // -- fill ratio histogram (rhp cannot divide histograms?!)
  rhp_hunpak(rich_fed_histo_id,fed_count);
  rhp_hunpak(rich_fed_refer_id,fed_refer);
  for (int i=0; i<nfed; i++) 
    fed_ratio[i]=fed_count[i]/(event_count*fed_refer[i]);
  rhp_hpak(rich_fed_ratio_id,fed_ratio);

  // -- publish
  //  DQ_RICH_publish();
  
  return 0;
}


