// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//  4 Nov 1999 (DD) beta=1 radius histogramm 
// 19 Nov 1999 (AG) show up
// 16 Dec 1999 (RP) likelihood histograms DQ_RICH_rec_pid()
// *****************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// includes
#include "dq/DQ.h"
#include "dq/DQ_RICH.h"

#include "arte/arte.hh"

#include "rhp.h"

/////////////////////  Declare RICH histograms /////////////////////////////
float DQ_RICH_rec_xmin=log(1);
float DQ_RICH_rec_xmax=log(200);
int   DQ_RICH_rec_nbin=20;

/// cherenkov angles
float DQ_RICH_rec_thc_xmin=0;
float DQ_RICH_rec_thc_xmax=0.06;
int   DQ_RICH_rec_thc_nbin=100;


int DQ_RICH_rec_init()
{
  cout << "DQ_RICH_rec_init()" << endl;

  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 200),"RICH: Number of RICH rings per event",50,-0.5,49.5);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 201),"RICH: track directions",50,-0.3,0.3,50,-0.3,0.3);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 202),"RICH: Cherenkov angle",60,0.03,0.05);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 203),"RICH: Beta=1 Cherenkov angle",400,0.02,0.06);


  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 204),
	     "RICH: Cherenkov angle for all (track,hit) pairs ",
	     DQ_RICH_rec_thc_nbin ,  
	     DQ_RICH_rec_thc_xmin ,
	     DQ_RICH_rec_thc_xmax );

  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 210),"RICH: rtra id={other,e,mu,pi,K,p}"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 211),"RICH: rtra->lre"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 212),"RICH: rtra->lrmu" ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 213),"RICH: rtra->lrpi" ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 214),"RICH: rtra->lrk"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 215),"RICH: rtra->lrp"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 216),"RICH: rtra->lrother",100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 217),"RICH: rtra->hri",100,0,100);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 218),"RICH: rtra->flr",100,0,100);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 219),"RICH: rtra->flr/allrtra",100,0,100);

  float xmin = DQ_RICH_rec_xmin ;
  float xmax = DQ_RICH_rec_xmax ;
  int   nbin = DQ_RICH_rec_nbin ;

  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 220),"RICH: log(rtra->lrpi/rtra->lrk)(log(p))"  ,100,0,1,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 221),"RICH: rtra->lre(log(p))"  ,100,0,1,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 222),"RICH: rtra->lrmu(log(p))" ,100,0,1,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 223),"RICH: rtra->lrpi(log(p))" ,100,0,1,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 224),"RICH: rtra->lrk(log(p))"  ,100,0,1,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 225),"RICH: rtra->lrp(log(p))"  ,100,0,1,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 226),"RICH: rtra->lrother(log(p))",100,0,1,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 227),"RICH: rtra->hri(log(p))",100,0,100,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 228),"RICH: rtra->flr(log(p))",100,0,100,nbin,xmin,xmax);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 229),"RICH: rtra->flr/allrtra(log(p))",100,0,100,nbin,xmin,xmax);


  return 0; // return error code (0 = okay)
}



