
// ******************************************************************
//
// M. Braeuer/ D. Samtleben
//
// Declaration of Histograms and Initialization
// Histogram ID:     32 bits
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte include
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_SVD.h"

//
// function code
//
int
DQ_SVD_rec_init()
{
#define VDS_MAXPLANES 128
#define VDS_plane_l  -0.5  // lower bound for plane
#define VDS_plane_h 127.5  // upper bound for plane

  cout << "DQ_VDS_rec_init()" << endl;
  
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,1000200),"VDS tracks/event",
	     200, -0.5, 199.5 );

  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,1000201),"VDS Hits/plane tracks",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h);
  rhp_hbook2(DQ_ID(COMP_SVD, LVL_REC,1000202),"VDS occupancy tracks",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h, 128,0.,1280.);
  rhp_hbook2(DQ_ID(COMP_SVD, LVL_REC,1000203),"VDS residuals",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h,100,-149,149);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,1000204),"VDS total residual",
	     100,-149,149);
  rhp_hbook2(DQ_ID(COMP_SVD, LVL_REC,1000205),"VDS Angular coverage tracks",
	     200,-249.9,249.9, 200,-249.9,249.9);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,1000206),"VDS hits/track",
	     25,-0.5,24.5);

  return 0; // return error code (0 = okay)
}
