
// ********************************************************************
//
// Routine:      DQ_evnt.C
// Author:       D.Samtleben
//
// Description:  calls the different DQ-routines
//
// Changes:
// 09 Sep 1999 (AG) replace cerr by cout
// 18 Oct 1999 (AG) introduce DQ.hh
// 20 Oct 1999 (AG) use DQ.h
// 28 Oct 1999 (AG) remove not used functions
// 17 Nov 1999 (AG) invoke DQ_FARM_rec_evnt()
// 24 Nov 1999 (AG) add MUON rec
//
// ********************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "event.h"

// ARTE includes
#include "arte/ArteProto.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_SVD.h"
//#include "dq/DQ_ITR.h"
#include "dq/DQ_HIPT.h"
#include "dq/DQ_OTR.h"
#include "dq/DQ_RICH.h"
//#include "dq/DQ_TRD.h"
#include "dq/DQ_ECAL.h"
#include "dq/DQ_MUON.h"
//#include "dq/DQ_FLT.h"
//#include "dq/DQ_SLT.h"
#include "dq/DQ_TLT.h"
#include "dq/DQ_FARM.h"
#include "dq/DQ_CORR.h"
#include "dq/DQ_RECO.h"
//#include "dq/DQ_USR1.h"
//#include "dq/DQ_USR2.h"

// prototypes
extern "C" void dqkuip_();

//
// initialize the Xyz kuip commands
//
static class DQIniter
{
public:
  DQIniter() { atregkuip( dqkuip_, 1 ); } 
} _dqIniter;

//********************************************************************
// DQ_evnt
//********************************************************************
int
DQ_evnt()
{
  // print settings
  // DQ_print();

  // init
  int dq_flag = 0;
  
  // get raw event
  EVENT_HDR *event = ARTE_get_event();

  // event functions  
  if( DQ_flag( COMP_SVD,  LVL_M_HIT ) ) dq_flag = DQ_SVD_hit_evnt();
  if( DQ_flag( COMP_SVD,  LVL_M_REC ) ) dq_flag = DQ_SVD_rec_evnt();

  if( DQ_flag( COMP_HIPT, LVL_M_RAW ) ) dq_flag = DQ_HIPT_raw_evnt( event );

  if( DQ_flag( COMP_OTR,  LVL_M_HIT ) ) dq_flag = DQ_OTR_hit_evnt();
  if( DQ_flag( COMP_OTR,  LVL_M_REC ) ) dq_flag = DQ_OTR_rec_evnt();

  if( DQ_flag( COMP_RICH, LVL_M_RAW ) ) dq_flag = DQ_RICH_raw_evnt( event );
  if( DQ_flag( COMP_RICH, LVL_M_HIT ) ) dq_flag = DQ_RICH_hit_evnt();
  if( DQ_flag( COMP_RICH, LVL_M_REC ) ) dq_flag = DQ_RICH_rec_evnt();

  if( DQ_flag( COMP_ECAL, LVL_M_HIT ) ) dq_flag = DQ_ECAL_hit_evnt();
  if( DQ_flag( COMP_ECAL, LVL_M_REC ) ) dq_flag = DQ_ECAL_rec_evnt();

  if( DQ_flag( COMP_MUON, LVL_M_HIT ) ) dq_flag = DQ_MUON_hit_evnt();
  if( DQ_flag( COMP_MUON, LVL_M_REC ) ) dq_flag = DQ_MUON_rec_evnt();

  if( DQ_flag( COMP_TLT,  LVL_M_REC ) ) dq_flag = DQ_TLT_rec_evnt();

  if( DQ_flag( COMP_FARM, LVL_M_HIT ) ) dq_flag = DQ_FARM_hit_evnt();
  if( DQ_flag( COMP_FARM, LVL_M_REC ) ) dq_flag = DQ_FARM_rec_evnt();

  if( DQ_flag( COMP_CORR, LVL_M_HIT ) ) dq_flag = DQ_CORR_hit_evnt();

  if( DQ_flag( COMP_RECO, LVL_M_REC ) ) rcDQevnt();
  
  //if( DQ_flag( COMP_USR1, LVL_M_REC ) ) dq_flag = ;
  //if( DQ_flag( COMP_USR2, LVL_M_REC ) ) dq_flag = ;

  return 0;
}
