
#ifndef _DQ_H_
#define _DQ_H_

/******************************************************************************
 *                                   
 * source:    DQ.h                   
 *                                  
 * type:      header file           
 *                                  
 * created:   19 Oct 1999           
 *                                  
 * author:    Andreas Gellrich      
 *            HERA-B Collaboration  
 *            DESY Zeuthen          
 *            Platanenallee 6       
 *            D-15738 Zeuthen       
 *            Germany               
 *            email: Andreas.Gellrichdesy.de                     
 *                                                               
 * changes:                                                      
 * 20 Oct 1999 (AG) make DQ_flag() usable for C                  
 * 27 Oct 1999 (AG) define modules (MOD) and levels (LVL)        
 * 01 Nov 1999 (AG) include CNA stuff
 * 16 Nov 1999 (AG) polishing
 * 19 Nov 1999 (AG) cna -> ac (alca)
 * 26 Nov 1999 (AG) COMP_USR3 -> COMP_RECO
 *
 *****************************************************************************/

/* includes */
#include "component.h"

/* components (see component.h) */
#define COMP_SVD  COMP_N_SVD
#define COMP_ITR  COMP_N_ITR
#define COMP_HIPT COMP_N_HIPT
#define COMP_OTR  COMP_N_OTR
#define COMP_RICH COMP_N_RICH
#define COMP_TRD  COMP_N_TRD
#define COMP_ECAL COMP_N_ECAL
#define COMP_MUON COMP_N_MUON

#define COMP_FLT  COMP_N_FLT
#define COMP_SLT  COMP_N_SLT
#define COMP_TLT  COMP_N_FARM
#define COMP_FARM COMP_N_DAQ

#define COMP_CORR COMP_N_FCS
#define COMP_RECO COMP_N_MPAD

#define COMP_USR1 COMP_N_TARG
#define COMP_USR2 COMP_N_MPIX

/* modules */
#define MOD_DQ     1
#define MOD_M_DQ   0x0002
#define MOD_ID_DQ  0x0100

#define MOD_REC    2
#define MOD_M_REC  0x0004
#define MOD_ID_REC 0x0200

#define MOD_AC    3
#define MOD_M_AC  0x0008
#define MOD_ID_AC 0x0300 

/* levels */
#define LVL_TST    0
#define LVL_M_TST  0x0001
#define LVL_ID_TST 0x0000

#define LVL_RAW    1
#define LVL_M_RAW  0x0002
#define LVL_ID_RAW 0x0100

#define LVL_HIT    2
#define LVL_M_HIT  0x0004
#define LVL_ID_HIT 0x0200

#define LVL_REC    3
#define LVL_M_REC  0x0008
#define LVL_ID_REC 0x0300

#define LVL_DEF    4
#define LVL_M_DEF  0x0010
#define LVL_ID_DEF 0x0400

#ifdef __cplusplus
extern "C" {
#endif

/* flag */
int DQ_flag( int COMP_XYZ, int LVL_M_ABC );
int AC_flag( int COMP_XYZ, int LVL_M_ABC );

/* histogram IDs */
unsigned int DQ_ID( int COMP_XYZ, int LVL_ABC, int histID );
unsigned int AC_ID( int COMP_XYZ, int LVL_ABC, int histID );

#ifdef __cplusplus
}
#endif

/* DB access */
int  DQ_db();
void DQ_print( const char *txt );

#endif
