#include <arte/ArteAll.hh>

void printDecayChain( ArtePointer<MTRA> mtra, unsigned int depth );

void example1()
{
  //
  // ArteTableIterator<t> for looping through an ARTE table.
  // Example: Loop through all MC-tracks and display pz
  //
 for ( ArteTableIterator<MTRX> mtrIt;
       mtrIt.valid();
       mtrIt.next() ) {
   cout << "MC-track" << mtrIt << ": pz=" << ArtePointer<MTRA>(mtrIt)->pz;
   cout << endl;
 } 
 //
 // ArteRelationIterator<t> for getting related objects
 // (look up the ARTE relation).
 // Example: find all MC-impact points of MC-track 3
 //          using the relation of the mimp-entry of MTRX
 //
 ArtePointer<MTRX> mtrp( 3 );
 // Pointer to MC-track 3.

 for ( ArteRelationIterator<MTRX_MIMP> mimpIt( mtrp->mimp );
       mimpIt.valid();
       mimpIt.next() ) {
   cout << "mimp:" << mimpIt << endl;
 }
 //
 // Print the decay chain of a B0 decay:
 //
 for ( ArteTableIterator<MTRA> mtra;
       mtra.valid(); mtra.next() ) {

   // Select B0 (Lund code 511)
   if ( ArtePointer<TOPP>(mtra->topp)->lund==511 ) {
     printDecayChain( mtra,1 );
   }
 }
  //
}



