
// *****************************************************************************
//
// source:    faCycle.C
//
// type:      source code
//
// created:   12 Feb 1999
// updated:    1 Jun 1999  Andreas Gellrich
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    faCycle()
//
// called by: faRead()
//
// purporse:  handling cycling by means of a stop file
//
// changes:   
//                  includes (AG: 23 Feb 99)
//                  polishing (AG: 1 Mar 99)
//                  polishing (AG: 11 Mar 99)
//                  put includes (AG: 1 Jun 99)
// 03 Nov 1999 (AG) renamed CYCLE to NOBLOCK
//
// *****************************************************************************

// standard includes
#include <iostream.h>
#include <unistd.h>

// Arte includes
#include "arte/ArteFlag.h"
#include "farm/fa.hh"

// externals
extern int FADEB;   // debug flag
extern int NOBLOCK; // no block emg
extern int WAIT;    // delay

//
// program code
//
void
faCycle()
{
  // sleep
  sleep( WAIT );

  // cycling ?
  if ( !NOBLOCK ){
    return;
  }

  // cycle
  FILE *in = 0;
  if( ( in = fopen( "cycle.stop", "r" ) ) ){
#ifdef _DEB_
    if( FADEB ){
      cout << "faCycle(): Found file cycle.stop" << endl;
    }
#endif
    arteflag_.neventl = 0;
    if( in ){
      fclose( in );
    }
  }
}
