// ********************************************************************
//
//  Routine:      gageFillRhp
//  Author:       T. Oest
//
//  Description:  steering routine to fill rhp histograms for global 
//                alignment
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include "arte/arte.hh"
#include "gage/gage.hh"
#include "arte/RSEG_cmp.hh"

FILE * gageFile = 0;

static int BufferInit = 0;

//*********************************************************************
// function
//*********************************************************************

int gageFillRhp() {

  int     cmpRSEG, cmpAlign;
  float * Cuts;

//---------------------------------------------------------------------
//  open disk file if required
//---------------------------------------------------------------------

  if (BufferInit == 0) {
   char *FileBuffer;
   FileBuffer = getenv("GAGE_BUFFER");
   if (FileBuffer) {
     BufferInit = 1;
     gageFile = fopen(FileBuffer,"w+");
   };
  };

//---------------------------------------------------------------------
//  fill rhp ring buffer for VDS, ECAL/RICH
//---------------------------------------------------------------------

  if (gageSelectVdsEcalRich == 1){

   cmpRSEG  =  Rsegc::ecal |  Rsegc::rich;
   cmpAlign =  Rsegc::vxd;
   Cuts     =  gageCutsVdsEcalRich;

   gageFillRhpSegments(cmpRSEG, cmpAlign, Cuts);

  };

//---------------------------------------------------------------------
//  fill rhp histograms for ECAL, RICH
//---------------------------------------------------------------------

  if (gageSelectRichEcal == 1) gageFillRhpRich();

//---------------------------------------------------------------------
//  
//---------------------------------------------------------------------

  return 0;
}
