// ********************************************************************
//
//  Routine:      gageFitEcalRich
//  Author:       T. Oest
//
//  Description:  VDS/RICH/TARGET match
//
//  Modification:
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>

#include "arte/arte.hh"

#include "reco/rc99fit98.hh"

//******************************************************************
// function
//******************************************************************
void gageFitEcalRich(ArtePointer<RSEG> rRICH, ArtePointer<RCCL> rccl,
                   float * pTRACK, float * chi2){

    float xECAL, yECAL, zECAL;
    float xTARGET = 0.0;
    float yTARGET = 0.0;
    float zTARGET = 0.0;

const int index[5][5] = { {0, 1,  3, 6,10},
                          {1, 2,  4, 7,11},
                          {3, 4,  5, 8,12},
                          {6, 7,  8, 9,13},
                          {10,11,12,13,14}};
const int index2[5][5] = { {0,1, 2, 3, 4},
                           {1,5, 6, 7, 8},
                           {2,6, 9,10,11},
                           {3,7,10,12,13},
                           {4,8,11,13,14}};
//-----------------------------------------------------------------
//   zTarget
//-----------------------------------------------------------------
    float diff;

    for( ArteTable<GTAR>::iterator gtar = ArteTable<GTAR>::begin();
         gtar != ArteTable<GTAR>::end();
         ++gtar ) {
      diff = (*gtar)->x * (*gtar)->x + (*gtar)->y * (*gtar)->y;
      if (diff < 1 ) {
        xTARGET  = (*gtar)->x;
        yTARGET  = (*gtar)->y;
        zTARGET  = (*gtar)->z;
      }
    };

//-----------------------------------------------------------------
//
//-----------------------------------------------------------------
    float pinv, ytarget, xtarget, tyRICH, txRICH;


      xECAL    = rccl->x;
      yECAL    = rccl->y;
      zECAL    = rccl->z;
      tyRICH   = rRICH->tyf;
      txRICH   = rRICH->txf;

      ytarget = yECAL + tyRICH * (zTARGET - zECAL);
      xtarget = xECAL + txRICH * (zTARGET - zECAL);
      pinv = - xtarget / 280.;     //  1/p



        float zmag = 450.;
        float xmag;
        xmag = xECAL + (zmag - zECAL) * rRICH->txf;

        double pstart[6];
        pstart[0] = zTARGET;
        pstart[1] = xTARGET;
        pstart[2] = yTARGET;
        pstart[3] = xmag / (zmag - zTARGET);
        pstart[4] = tyRICH;
        pstart[5] = pinv;



       double z, pMeas[5], wMeas[5][5];
        for (int i=0;i<5;i++){for (int j=0;j<5;j++){wMeas[i][j]=0.0;};}


        track_98 track(pstart);

	// target spot 

        z        = zTARGET;
        pMeas[0] = xTARGET;
        pMeas[1] = yTARGET;
        pMeas[2] = pstart[3];
        pMeas[3] = pstart[4];
        pMeas[4] = pstart[5];
        wMeas[0][0] = 10.0;
        wMeas[1][1] = 10.0;

        track.add_measurement(z, &pMeas[0], &wMeas[0][0]);

	// ECAL, RICH

        float a;
 

        z        = zECAL;
        pMeas[0] = xECAL;
        pMeas[1] = yECAL;
        pMeas[2] = txRICH;
        pMeas[3] = tyRICH;
        pMeas[4] = pstart[5];

        a = rccl->cve[0] * rccl->cve[2] - 
            rccl->cve[1] * rccl->cve[1];
        if (a != 0.0){
         wMeas[0][0] =   rccl->cve[2] / a;
         wMeas[1][1] =   rccl->cve[0] / a;
         wMeas[1][0] = - rccl->cve[1] / a;
         wMeas[0][1] = wMeas[1][0];
        } else {
         wMeas[0][0] = 1./rccl->cve[0];
         wMeas[1][1] = 1./rccl->cve[2];
         wMeas[1][0] = 0.0;
         wMeas[0][1] = 0.0;
        };

        a = rRICH->cvf[5]  * rRICH->cvf[9] - 
            rRICH->cvf[8]  * rRICH->cvf[8];
        if (a != 0.0){
         wMeas[2][2] =   rRICH->cvf[9] / a;
         wMeas[3][3] =   rRICH->cvf[5]  / a;
         wMeas[3][2] = - rRICH->cvf[8]  / a;
         wMeas[2][3] = wMeas[3][2];
        } else {
         wMeas[2][2] = 1./rRICH->cvf[5];
         wMeas[3][3] = 1./rRICH->cvf[9];
         wMeas[3][2] = 0.0;
         wMeas[2][3] = 0.0;
        };

        track.add_measurement(z, &pMeas[0], &wMeas[0][0]);

	// fit
        *chi2 = float(track.fit());

        double * parameters, * covariance;;
        parameters  = track.track_parameters();
        float p     = 1./fabs(float(parameters[5]));
        covariance  = track.track_errors();

        pTRACK[0]  = zTARGET;
	pTRACK[1]  = xTARGET;
	pTRACK[2]  = yTARGET;
        pTRACK[3]  = float(parameters[3]);
        pTRACK[4]  = float(parameters[4]);
        pTRACK[5]  = float(parameters[5]);

   /*
   cout << "  z    " << pTRACK[0] << endl;
   cout << "  x    " << pTRACK[1] << endl;
   cout << "  y    " << pTRACK[2] << endl;
   cout << "  tx   " << pTRACK[3] << endl;
   cout << "  ty   " << pTRACK[4] << endl;
   cout << "  p    " << pTRACK[5] << endl;
   */

};



