// ********************************************************************
//
//  Routine:      kagageselect
//  Author:       T.Oest
//
//  Description:  select components to be written to rhp ring buffer
//
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"

int   gageSelectVdsEcalRich = 0;
int   gageSelectRichEcal    = 0;
int   gageSelectVdsOtr      = 0;
float gageCutsVdsEcalRich[5];
float gageCutsRichEcal[5]   ;
float gageCutsVdsOtr[5]     ;

extern "C" void kugeti_(int*);
extern "C" void kugetr_(float*);
extern "C" void kugetc_( char*, int *, int );

extern "C" void kagageselect_() {   

//---------------------------------------------------------------
//   read in component to be aligned
//---------------------------------------------------------------

  int len;
  int len1 = 5;
  char input[9];
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *Segment1;
  Segment1  = (char *) malloc(len+1);
  sprintf(Segment1  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) Segment1[i] = toupper(input[i]);

//---------------------------------------------------------------
//   reference component
//---------------------------------------------------------------

  len1 = 5;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *Segment2;
  Segment2  = (char *) malloc(len+1);
  sprintf(Segment2  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) Segment2[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read cuts
//---------------------------------------------------------------

  float dx, dy, dtx, dty, pmin;

  kugetr_(&dx);
  kugetr_(&dy);
  kugetr_(&dtx);
  kugetr_(&dty);
  kugetr_(&pmin);

//---------------------------------------------------------------
//   set gage status
//---------------------------------------------------------------


  if ( !strncmp(Segment1,"VDS"   ,3)  &&
      (!strncmp(Segment2,"ECALR" ,5)||!strncmp(Segment2,"RICHE" ,5))){
       gageSelectVdsEcalRich  = 1;
       gageCutsVdsEcalRich[0] = dx;
       gageCutsVdsEcalRich[1] = dy;
       gageCutsVdsEcalRich[2] = dtx;
       gageCutsVdsEcalRich[3] = dty;
       gageCutsVdsEcalRich[4] = pmin;
  };

  if (!strncmp(Segment1,"RICH" ,4) && !strncmp(Segment2,"ECAL" ,4)){
       gageSelectRichEcal  = 1;
       gageCutsRichEcal[0] = dx;
       gageCutsRichEcal[1] = dy;
       gageCutsRichEcal[2] = dtx;
       gageCutsRichEcal[3] = dty;
       gageCutsRichEcal[4] = pmin;
  };

  if (!strncmp(Segment1,"VDS"  ,3) && !strncmp(Segment2,"OTR" ,3)){
       gageSelectVdsOtr  = 1;
       gageCutsVdsOtr[0] = dx;
       gageCutsVdsOtr[1] = dy;
       gageCutsVdsOtr[2] = dtx;
       gageCutsVdsOtr[3] = dty;
       gageCutsVdsOtr[4] = pmin;
  };

};
