/***********************************************************************
*-- author :    a. pose/siegmund nowak
*
* this routines makes a random distribution of interaction vertices 
* on wire targets
*
*       called from hgkine
*
* arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*   xm       out          position vector of an interaction 
*
***********************************************************************/
#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/zgbeam.h"
#include <vector.h>
extern 
#include "gean/zginteract.hh"

extern "C" {
   void grndm_(float [],int *);
   void granor_(float *, float*);
}

void cr_ipoint(int &iev, float xm[], float &time_gen) {  
   int i2 =2;
   float ar[2], rn, dummy, wl1,wl2;
   grndm_(ar,&i2);
   int ie = iev-1;
   if(iev > int(ip_wire.size())) {
     arteMsg << "cr_ipoint: noncorrespondence between ip_wire size and nmcme "
             <<  ip_wire.size() << " " << iev ;
     arteMsg.warn();
     ie = 0;
   }	          

   ArtePointer<GTAR> gt(ip_wire[ie]);
   if(gt->shap ==1) {
      if(gt->dx > gt->dy)  {                             //  horizontal wires
         wl1 = ( .5*gt->dx - gt->x0bm) / gt->sxbm;
         wl2 = (-.5*gt->dx - gt->x0bm) / gt->sxbm;
         granor_(&rn,&dummy);
         while (rn > wl1 || rn < wl2) granor_(&rn,&dummy);
         xm[0] = rn * gt->sxbm + gt->x0bm + gt->x ;
         xm[1] = (ar[0] - .5) * gt->dy + gt->y;
      }
      else {                                            //   vertical wires
         wl1 = ( .5*gt->dy-gt->y0bm)/gt->sybm;
         wl2 = (-.5*gt->dy-gt->y0bm)/gt->sybm;
         granor_(&rn,&dummy);
         while (rn > wl1 || rn < wl2) granor_(&rn,&dummy);
         xm[0] = (ar[0] - .5) * gt->dx + gt->x;
         xm[1] = rn * gt->sybm + gt->y0bm + gt->y;
      }
      xm[2] = (ar[1] - .5) * gt->dz + gt->z;
   } 
   else if(gt->shap == 5) { 
      float x1, x2, x3, r, phi;
      r = 0.5*ar[0]*gt->dy;  phi = ar[1]*AR_TWOPI;  
      x1 = r * cos(phi); x2 = r*sin(phi);
      if(fabs(gt->dz*gt->rot[2]) > fabs(gt->dz*gt->rot[5])) {
         wl1 = ( .5*gt->dz - gt->x0bm) / gt->sxbm;  
         wl2 = (-.5*gt->dz - gt->x0bm) / gt->sxbm;
         granor_(&rn,&dummy);
         while (rn > wl1 || rn < wl2) granor_(&rn,&dummy);         
         x3 = rn * gt->sxbm + gt->x0bm;
       }
      else {
         wl1 = ( .5*gt->dz - gt->y0bm) / gt->sybm;  
         wl2 = (-.5*gt->dz - gt->y0bm) / gt->sybm;
         granor_(&rn,&dummy);
         while (rn > wl1 || rn < wl2) granor_(&rn,&dummy);         
         x3 = rn * gt->sybm + gt->y0bm;
       }
      xm[0]=gt->rot[0]*(x1+gt->x)+gt->rot[1]*(x2+gt->y)+gt->rot[2]*(x3+gt->z);  
      xm[1]=gt->rot[3]*(x1+gt->x)+gt->rot[4]*(x2+gt->y)+gt->rot[5]*(x3+gt->z);
      xm[2]=gt->rot[6]*(x1+gt->x)+gt->rot[7]*(x2+gt->y)+gt->rot[8]*(x3+gt->z);  
   }

// time distribution 
   time_gen = 0.;
   if(zgbeam_.time_swit == 1)  {
   granor_(&rn,&dummy);
   time_gen = rn * zgbeam_.sigb_time + zgbeam_.meanb_time;
   }
  }






