/***********************************************************************
*-- author :    siegmund nowak 8/96
*
* this routines stores de/dx into arte gmat tables
*
* called from hginit
*
***********************************************************************/
#include <string.h>
#include <math.h>
#include "gean/gcphys.h"
#include "gean/gclink.h"
#include "arte/arte.hh"

extern "C" { 

void medcon_() {      
  float jx;

  for(ArteTableIterator<GMAT> gm; gm.valid(); gm.next()){
      int jma = *(gcbank_.lq + gclink_.jmate -1 -gm.index() );
      if(jma <= 0)  continue; 
      int jma1 = *(gcbank_.lq + jma -4);
      memcpy(&jx,gcbank_.iq + jma1 + *(gcbank_.iq +jma1-2) -1,4);
       
      if(*(&gcphys_.iloss) != 2 && jx > 1.e-8)
                    jx = jx * (1.88 + .0289*log(double(jx))); 
      (*gm)->loss = jx;
  }  

  for(ArteTableIterator<NEDE> nd; nd.valid(); nd.next()){
      ArtePointer<GMAT> gm = (*nd)->gmat;
      (*nd)->dedx = ((*nd)->zmax-(*nd)->zmin) * gm->loss;  
  }
  for(ArteTableIterator<NWAL> nw; nw.valid(); nw.next()){
      ArtePointer<GMAT> gm =(*nw)->gmat;
      (*nw)->dedx = ((*nw)->zmax-(*nw)->zmin) * gm->loss;
  }
}
}



