/***********************************************************************
*
* TAR_ARTE
* written by Siegmund Nowak
*
* This routines implements the NTAR bank
* banks for the SVD 
*
*       called from cr_arte_user
*
* The transferred parameters are
* void tar_arte_(int nede,int nwal,char lvols[],int lcopy[],int nlev)
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/zgeom.h"
#include "gean/ZGESL.h"

void tar_arte(int,int nwal,char lvols[],int lcopy[],int nlev) {
    if(nwal!=0) { 
      ArtePointer<NWAL> cr(nwal);
      ArtePointer<GMAT> gm = cr->gmat;
     struct NTAR gt;               
     char volname[5]; 
     zgvol ZGVOL;
     strncpy(volname,&lvols[4*nlev],4);
     int type = lcopy[nlev];
     int itype = type>>16;
     int nr_vol = ZGVOL.Get_volnr(volname,itype);
     memset(&gt,0,sizeof(gt));
     gt.cmp  = gm.index();   
     gt.wnr  = itype;
     if(cr->shp ==1) {
         gt.dx   = cr->xmax - cr->xmin;
         gt.dy   = cr->ymax - cr->ymin;
         gt.dz   = cr->zmax - cr->zmin;
         gt.x    = 0.5*(cr->xmax + cr->xmin);
         gt.y    = 0.5*(cr->ymax + cr->ymin);
         gt.z    = 0.5*(cr->zmax + cr->zmin);
     }
     else if(cr->shp ==5) {
         gt.x = cr->ymin; 
         gt.y = cr->ymax; 
         gt.z = 0.5*(cr->zmax + cr->zmin); 
         gt.dx   = 2. * cr->xmax;
         gt.dy   = 2. * cr->xmax;
         gt.dz   = cr->zmax - cr->zmin;
     }
     memcpy(&gt.rot[0],&cr->rot[0],36);
     gt.shap   = cr->shp; 
     gt.ms     = cr->ms; 
     strncpy(gt.name,ZGVOL.Get_fullname(nr_vol),4);
     gt.eff = 1.; 
   
     char tag[16];
     zguser ZGUSER;
     for(int i =0;i<ZGVOL.Get_nuser(nr_vol); i++) {
        char *card = ZGUSER.Get_Buffer(LGESL_TAR,nr_vol,i);
        int nitem=sscanf(card,"%s",tag);
        card+=itemlength(card,nitem);
        ToLower(tag);
        if (!strncmp(tag,"beam",4)) {
           nitem=sscanf(card,"%f %f %f %f ",&gt.x0bm, &gt.sxbm, 
                                            &gt.y0bm, &gt.sybm);
           if (nitem!=4) {
               arteMsg << "tar_arte: check beam card " << card; 
	       arteMsg.error();
           }
	}
        else if (!strncmp(tag,"eff",3)) {
           nitem=sscanf(card,"%f ",&gt.eff); 
           if (nitem!=1) {
               arteMsg << "tar_arte: check effectivity card " << card; 
	       arteMsg.error();
	   }
	}
        else { 
           arteMsg << "tar_arte: key " << tag << " not defined"; 
	   arteMsg.error();
       } 
      }
     ArteTable<NTAR>::push_back(gt); 
    }
       
  }


