*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE LIIOTA (LUN, CTPL)

************************************************************************
*
* Description: Print information on logical unit number LUN.
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   LUN    in     Logical unit number. If LUN = 0: all units
*   CTPL   in     Print destination (combination of 'TPL')
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"
#include "auto/MEMO.fi"

      INTEGER LUN, L0, L1, L2, I, IL, LENOCC
      CHARACTER CN*80, CC*85, CTPL*(*)

#include "arte/Arte.ff"
#include "auto/MEIO.ff"
#include "auto/MEMO.ff"

      L1 = 1
      L2 = 99
      IF (LUN .NE. 0)  THEN
        L1 = LUN
        L2 = LUN
      END IF

      CALL MESELP (
     +  'Lun stream        tables;  /< no input /> no output', CTPL)

      DO 30 L0 = L1, L2
        IF (IMEIO_FLAG(L0) .LT. 0 .OR.
     +      HMEIO_BIT(L0) .EQ. 0)  GO TO 30

        WRITE (C78, '(I3)') L0
        IL = 0

        CALL CHHTOC (IQ(HQMEIO_STREAM(1,L0)), C78(5:84))
        DO 20 I = 2, NMEMO()

          IF (IAND (BMEMO_IOA(I), BIT(HMEIO_BIT(L0))) .EQ. 0 .AND.
     +        IAND (BMEMO_IOD(I), BIT(HMEIO_BIT(L0))) .EQ. 0) GO TO 20
          CC = ' '
          IF (IAND (BMEMO_IOA(I), BIT(1)) .EQ. 0)  CC(1:2) = '/<'
          IF (IAND (BMEMO_IOA(I), BIT(2)) .EQ. 0)
     +      CALL CHAPPC (CC, '/>')
          IF (IAND (BMEMO_IOA(I), BIT(HMEIO_BIT(L0))) .EQ. 0)
     +      CALL CHAPPC (CC, '/')
          CALL CHHTOC (IQ(HQMEMO_NAME(1,I)), CN)
          CALL CHAPPC (CC, CN)
          CALL CHAPBC (C78(18:), CC)

          IL = 1
          IF (LENOCC(C78) .GT. 80)  THEN
            CALL ME78SP (CTPL)
            C78 = ' '
            IL = 0
          END IF

 20     CONTINUE

        IF (IL .NE. 0)  CALL ME78SP (CTPL)

 30   CONTINUE

 90   END

************************************************************************
* End of LIIOTA
************************************************************************
