
//## Boris Fominykh  20.12.1999
//## functions of class MuDbNede

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

#include "murec/MuDbNede.h"

//** Constructor */
MuDbNede::MuDbNede()
  :  MuDbTable::MuDbTable()
{
  Ini();
  strncpy(DBtable,"MuonNede",9);
  strncpy(Desc,"I:allint F:allfloat A:allchar",30);
  strncpy(Title,"Muon NEDE elements",19);
}

//** Destructor */
MuDbNede::~MuDbNede()
{
}

//## Methods

//** Initialization */
void MuDbNede::Ini()
{
  Nnede=1000;
  Status = 0;
  Ncollect = 0;
  SizeW  = 0;
  ElIntW = NULL;
  ElFlW  = NULL;
  ElChW  = NULL;
  return;
}
 
//** Book temporary space */
int MuDbNede::Book()
{
  if(Nnede <= 0) {
    cout << "MuDbNede::Book - Nnede= " << dec << Nnede;
    cout << " is NOT set" << endl;
    return 1; 
  }
  if(SizeW == Nnede) return 0;
  ElIntW = new int[NelInt*Nnede];
  if(ElIntW == NULL) return 2;
  ElFlW = new float[NelFloat*Nnede];
  if(ElFlW == NULL) {
    delete []ElIntW;
    return 3;
  }
  ElChW = new char[NelChar*Nnede];
  if(ElChW == NULL) {
    delete []ElIntW;
    delete []ElFlW;
    return 4;
  }
  SizeW = Nnede;
  Status=0;
  Ncollect = 0;
  int* pel = ElIntW;
  for(int i=0; i<NelInt*SizeW; i++) *(pel+i)=0;
  float* pelf = ElFlW;
  for(int i=0; i<NelFloat*SizeW; i++) *(pelf+i)=0.;
  char* pelch = ElChW;
  for(int i=0; i<NelChar*SizeW; i++) *(pelch+i)=' ';
  return 0;
}

//** Release the temporary space*/
void MuDbNede::Release()
{
  if(SizeW > 0) {
    delete []ElIntW;
    delete []ElFlW;
    delete []ElChW;
    Status = 0;
    Ncollect = 0;
    SizeW  = 0;
    ElIntW = NULL;
    ElFlW  = NULL;
    ElChW  = NULL;
  }
  return;
}

//** Read the table from DB into booked temporary space*/
int MuDbNede::Read()
{
  Status = 0;
  Ncollect = 0;
  int ret=0;
  int nel=0;
// open DB
  ret=MuDbTable::Open(0);
  if(ret != 0) return ret;
// fetch the table
  ret=MuDbTable::Fetch();
  if(ret != 0) goto labelexit;
// book the space
  Nnede=Size/NelFloat;
  ret=MuDbNede::Book();
  if(ret != 0) return 21;
// read the table from DB
  Nf=SkipTableField(X,1);
  nel = GetTableField(X,TABLEint,NelInt*SizeW,ElIntW);
  if(nel <= 0) {
    ret=31;
    goto labelexit;
  }
  Nf=SkipTableField(X,2);
  nel = GetTableField(X,TABLEfloat,NelFloat*SizeW,ElFlW);
  if(nel <= 0) {
    ret=32;
    goto labelexit;
  }
  Nf=SkipTableField(X,3);
  nel = GetTableField(X,TABLEascii,NelChar*SizeW,ElChW);
  if(nel <= 0) {
    ret=33;
    goto labelexit;
  }
// close DB;
  Status = 1;
  ret = 0;
labelexit:
  MuDbTable::Close();
  return ret;
}

//** Write the table from temporary space to DB */
int MuDbNede::Write()
{
  if(SizeW <= 0) return 1;
  if(Status != 2) return 2;
  if(Ncollect < 1) return 3;
// open DB
  int ret=MuDbTable::Open(1);
  if(ret > 0) return ret;
// write the table to DB
  SkipTableField(X,1);
  int ret1=PutTableField(X,TABLEint,NelInt*Ncollect,ElIntW);
  int ret2=PutTableField(X,TABLEfloat,NelFloat*Ncollect,ElFlW);
  int ret3=PutTableField(X,TABLEascii,NelChar*Ncollect,ElChW);
  int ret4=StoreTable(X,T,0);
// release the temporary space
  MuDbNede::Release();
// close DB;
  MuDbTable::Close();
//
  if(ret1 > 0 && ret2 > 0 && ret3 > 0 && ret4 > 0) return 0;
  if(ret1 <= 0) return 11; 
  if(ret2 <= 0) return 12; 
  if(ret3 <= 0) return 13; 
  if(ret4 <= 0) return 14; 
  return 15;
}

//** Get one NEDE element from temporary space*/
int MuDbNede::Get(int* key,MuNede* pnede)
{
  pnede->Ini();

  if(Status != 0 && Status != 1) {
    cout << "MuDbNede::Get - Status= " << Status;
    cout << " No actions" << endl;
    return 41;
  }
  if(Status != 1) {  
    int ret=MuDbNede::Read();
    if(ret != 0) return ret;
  }
// look for key
  int* pkey=ElIntW;
  float* elfl=ElFlW;
  char*  elch=ElChW;
  for(int i=0; i<SizeW; i++) {
    if(*pkey == 0) break;
    if(*pkey == *key) {
      pnede->Valid = -1;

// extract the integers
      pnede->nedekey = *pkey;
      pnede->inede   = *(pkey+1);
      for(int j=0; j<4; j++) pnede->nwi[j]  = *(pkey+j+2);
      pnede->nsl     = *(pkey+6);
      pnede->cmp     = *(pkey+7);
      pnede->lay     = *(pkey+8);
      pnede->sec     = *(pkey+9);
      pnede->shp     = *(pkey+10);
      pnede->nwl     = *(pkey+11);
      pnede->fwl     = *(pkey+12);
      pnede->gcop    = *(pkey+13);
      pnede->nesl    = *(pkey+14);
      pnede->neslkey = *(pkey+15);

// extract the floats
      for(int j=0; j<9; j++) pnede->rot[j]  = *(elfl+j);
      for(int j=0; j<4; j++) pnede->xfw[j]  = *(elfl+j+9);
      for(int j=0; j<4; j++) pnede->zfw[j]  = *(elfl+j+13);
      for(int j=0; j<4; j++) pnede->y1w[j]  = *(elfl+j+17);
      for(int j=0; j<4; j++) pnede->y2w[j]  = *(elfl+j+21);
      pnede->xmin = *(elfl+25);
      pnede->xmax = *(elfl+26);
      pnede->ymin = *(elfl+27);
      pnede->ymax = *(elfl+28);
      pnede->zmin = *(elfl+29);
      pnede->zmax = *(elfl+30);
      pnede->sxmn = *(elfl+31);
      pnede->sxmx = *(elfl+32);
      pnede->symn = *(elfl+33);
      pnede->symx = *(elfl+34);
      pnede->acc  = *(elfl+35);
      pnede->eff  = *(elfl+36);
      pnede->dod  = *(elfl+37);
      pnede->pit  = *(elfl+38);
      pnede->ms   = *(elfl+39);
      pnede->cos  = *(elfl+40);
      pnede->sin  = *(elfl+41);
      pnede->dedx = *(elfl+42);
      pnede->xmad = *(elfl+43);
      pnede->ymad = *(elfl+44);
      pnede->zmad = *(elfl+45);
      pnede->noise= *(elfl+46);
      pnede->ares = *(elfl+47);

// extract the characters
      char hwcw[13];
      strncpy(&hwcw[0],elch,13);
      hwcw[8]='\0';
      strncpy(&(pnede->hwc[0]),&hwcw[0],13);

      char gvolw[5];
      strncpy(&gvolw[0],elch+13,5);
      gvolw[4]='\0';
      strncpy(&(pnede->gvol[0]),&gvolw[0],5);

      pnede->Valid = 1;
      return 0;
    }
    pkey += NelInt;
    elfl += NelFloat;
    elch += NelChar;
  }
  cout << "MuDbNede::Get - key " << dec << *key;
  cout << " is NOT found" << endl;
  return 42;
}

//** Add one element to the temporary arrays */
int MuDbNede::Add(MuNede* pnede)
{
  if(Status != 0 && Status != 2) {
    cout << "MuDbNede::Add - Status= " << Status;
    cout << " No actions" << endl;
    return 41;
  }
  if(Status != 2) {  
    Nnede=1000;
    int ret=MuDbNede::Book();
    if(ret != 0) return ret;
    Status=2;
  }
  if(Ncollect >= SizeW) {
    cout << "MuDbNede::Add - Ncollect= " << Ncollect;
    cout << " SizeW= " << SizeW << " is NOT enough" << endl;
    return 42;
  }

// pointers
  int* pkey=ElIntW+Ncollect*NelInt;
  float* elfl=ElFlW+Ncollect*NelFloat;
  char*  elch=ElChW+Ncollect*NelChar;

// add the integers
  *pkey = pnede->nedekey;
  *(pkey+1)=pnede->inede;
  for(int j=0; j<4; j++) *(pkey+j+2)=pnede->nwi[j];
  *(pkey+6)=pnede->nsl;
  *(pkey+7)=pnede->cmp;
  *(pkey+8)=pnede->lay;
  *(pkey+9)=pnede->sec;
  *(pkey+10)=pnede->shp;
  *(pkey+11)=pnede->nwl;
  *(pkey+12)=pnede->fwl;
  *(pkey+13)=pnede->gcop;
  *(pkey+14)=pnede->nesl;
  *(pkey+15)=pnede->neslkey;

// add the floats
  for(int j=0; j<9; j++) *(elfl+j)=pnede->rot[j];
  for(int j=0; j<4; j++) *(elfl+j+9)=pnede->xfw[j];
  for(int j=0; j<4; j++) *(elfl+j+13)=pnede->zfw[j];
  for(int j=0; j<4; j++) *(elfl+j+17)=pnede->y1w[j];
  for(int j=0; j<4; j++) *(elfl+j+21)=pnede->y2w[j];
  *(elfl+25)=pnede->xmin;
  *(elfl+26)=pnede->xmax;
  *(elfl+27)=pnede->ymin;
  *(elfl+28)=pnede->ymax;
  *(elfl+29)=pnede->zmin;
  *(elfl+30)=pnede->zmax;
  *(elfl+31)=pnede->sxmn;
  *(elfl+32)=pnede->sxmx;
  *(elfl+33)=pnede->symn;
  *(elfl+34)=pnede->symx;
  *(elfl+35)=pnede->acc;
  *(elfl+36)=pnede->eff;
  *(elfl+37)=pnede->dod;
  *(elfl+38)=pnede->pit;
  *(elfl+39)=pnede->ms;
  *(elfl+40)=pnede->cos;
  *(elfl+41)=pnede->sin;
  *(elfl+42)=pnede->dedx;
  *(elfl+43)=pnede->xmad;
  *(elfl+44)=pnede->ymad;
  *(elfl+45)=pnede->zmad;
  *(elfl+46)=pnede->noise;
  *(elfl+47)=pnede->ares;
  
// add the characters
  char hwcw[13];
  strncpy(&hwcw[0],&(pnede->hwc[0]),13);
  hwcw[8]='\0';
  strncpy(elch,&hwcw[0],13);

  char gvolw[5];
  strncpy(&gvolw[0],&(pnede->gvol[0]),5);
  gvolw[4]='\0';
  strncpy(elch+13,&gvolw[0],5);

  Ncollect += 1;
  return 0;
}
