
//## Boris Fominykh  21.12.1999
//member functions of class MuDbNesl

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

#include "murec/MuDbNesl.h"

//** Constructor */
MuDbNesl::MuDbNesl()
  :  MuDbTable::MuDbTable()
{
  Ini();
  Nnesl  = 8;
  strncpy(DBtable,"MuonNesl",9);
  strncpy(Desc,"I:allint F:allfloat A:allchar",30);
  strncpy(Title,"Muon NESL elements",19);
}

//** Destructor */
MuDbNesl::~MuDbNesl()
{
}

//## Methods

//** Initialization */
void MuDbNesl::Ini()
{
  Status = 0;
  Ncollect = 0;
  SizeW  = 0;
  ElIntW = NULL;
  ElFlW  = NULL;
  ElChW  = NULL;
  return;
}
 
//** Book temporary space */
int MuDbNesl::Book()
{
  if(Nnesl <= 0) {
    cout << "MuDbNesl::Book - Nnesl= " << dec << Nnesl;
    cout << " is NOT set" << endl;
    return 1; 
  }
  if(SizeW == Nnesl) return 0;
  ElIntW = new int[NelInt*Nnesl];
  if(ElIntW == NULL) return 2;
  ElFlW = new float[NelFloat*Nnesl];
  if(ElFlW == NULL) {
    delete []ElIntW;
    return 3;
  }
  ElChW = new char[NelChar*Nnesl];
  if(ElChW == NULL) {
    delete []ElIntW;
    delete []ElFlW;
    return 4;
  }
  SizeW = Nnesl;
  Status=0;
  Ncollect = 0;
  int* pel = ElIntW;
  for(int i=0; i<NelInt*SizeW; i++) *(pel+i)=0;
  //  float* pelf = ElFlW;
  //  for(int i=0; i<NelFloat*SizeW; i++) *(pelf+i)=0.;
  //  char* pelch = ElChW;
  //  for(int i=0; i<NelChar*SizeW; i++) *(pelch+i)=' ';
  return 0;
}

//** Release the temporary space*/
void MuDbNesl::Release()
{
  if(SizeW > 0) {
    delete []ElIntW;
    delete []ElFlW;
    delete []ElChW;
    Status = 0;
    Ncollect = 0;
    SizeW  = 0;
    ElIntW = NULL;
    ElFlW  = NULL;
    ElChW  = NULL;
  }
  return;
}

//** Read the table from DB into booked temporary space*/
int MuDbNesl::Read()
{
  Status = 0;
  Ncollect = 0;
  int ret=0;
  int nel=0;
// book the space
  ret=MuDbNesl::Book();
  if(ret != 0) return 21;
// open DB
  ret=MuDbTable::Open(0);
  if(ret != 0) return ret;
// fetch the table
  ret=MuDbTable::Fetch();
  if(ret != 0) goto labelexit;
// read the table from DB
  Nf=SkipTableField(X,1);
  nel = GetTableField(X,TABLEint,NelInt*SizeW,ElIntW);
  if(nel <= 0) {
    ret=31;
    goto labelexit;
  }
  Nf=SkipTableField(X,2);
  nel = GetTableField(X,TABLEfloat,NelFloat*SizeW,ElFlW);
  if(nel <= 0) {
    ret=32;
    goto labelexit;
  }
  Nf=SkipTableField(X,3);
  nel = GetTableField(X,TABLEascii,NelChar*SizeW,ElChW);
  if(nel <= 0) {
    ret=33;
    goto labelexit;
  }
// close DB;
  Status = 1;
  ret = 0;
labelexit:
  MuDbTable::Close();
  return ret;
}

//** Write the table from temporary space to DB */
int MuDbNesl::Write()
{
  if(SizeW <= 0) return 1;
  if(Status != 2) return 2;
  if(Ncollect < 1) return 3;
// open DB
  int ret=MuDbTable::Open(1);
  if(ret > 0) return ret;
// write the table to DB
  SkipTableField(X,1);
  int ret1=PutTableField(X,TABLEint,NelInt*Ncollect,ElIntW);
  int ret2=PutTableField(X,TABLEfloat,NelFloat*Ncollect,ElFlW);
  int ret3=PutTableField(X,TABLEascii,NelChar*Ncollect,ElChW);
  int ret4=StoreTable(X,T,0);
// release the temporary space
  MuDbNesl::Release();
// close DB;
  MuDbTable::Close();
//
  if(ret1 > 0 && ret2 > 0 && ret3 > 0 && ret4 > 0) return 0;
  if(ret1 <= 0) return 11; 
  if(ret2 <= 0) return 12; 
  if(ret3 <= 0) return 13; 
  if(ret4 <= 0) return 14; 
  return 15;
}

//** Get one NESL element from temporary space*/
int MuDbNesl::Get(int* key,MuNesl* pnesl)
{
  if(Status != 0 && Status != 1) {
    cout << "MuDbNesl::Get - Status= " << Status;
    cout << " No actions" << endl;
    return 41;
  }
  if(Status != 1) {  
    int ret=MuDbNesl::Read();
    if(ret != 0) return ret;
  }
// look for key
  int* pkey=ElIntW;
  float* elfl=ElFlW;
  char*  elch=ElChW;
  for(int i=0; i<SizeW; i++) {
    if(*pkey == 0) break;
    if(*pkey == *key) {
      pnesl->Valid = -1;

// extract the integers
      pnesl->neslkey = *pkey;
      pnesl->inesl   = *(pkey+1);
      pnesl->cmp     = *(pkey+2);
      pnesl->shp     = *(pkey+3);
      pnesl->nsl     = *(pkey+4);
      pnesl->mfl     = *(pkey+5);
      pnesl->lay     = *(pkey+6);
      pnesl->npl     = *(pkey+7);
      pnesl->fpl     = *(pkey+8);
      pnesl->nwl     = *(pkey+9);
      pnesl->fwl     = *(pkey+10);
      pnesl->ltyp    = *(pkey+11);
      pnesl->pnsl    = *(pkey+12);
      for(int j=0; j<6; j++) pnesl->chamb[j] = *(pkey+j+13);
      for(int j=0; j<6; j++) pnesl->nx99[j]  = *(pkey+j+19);

// extract the floats
      pnesl->x1 = *(elfl);
      pnesl->x2 = *(elfl+1);
      pnesl->y1 = *(elfl+2);
      pnesl->y2 = *(elfl+3);
      pnesl->z1 = *(elfl+4);
      pnesl->z2 = *(elfl+5);
      pnesl->dx = *(elfl+6);
      pnesl->dy = *(elfl+7);

// extract the characters
      char nam[5];
      strncpy(&nam[0],elch,5);
      nam[4]='\0';
      strncpy(&(pnesl->name[0]),&nam[0],5);

      pnesl->Valid = 1;
      return 0;
    }
    pkey += NelInt;
    elfl += NelFloat;
    elch += NelChar;
  }
  cout << "MuDbNesl::Get - key " << dec << *key;
  cout << " is NOT found" << endl;
  return 42;
}

//** Add one element to the temporary arrays */
int MuDbNesl::Add(MuNesl* pnesl)
{
  if(Status != 0 && Status != 2) {
    cout << "MuDbNesl::Add - Status= " << Status;
    cout << " No actions" << endl;
    return 41;
  }
  if(Status != 2) {  
    int ret=MuDbNesl::Book();
    if(ret != 0) return ret;
    Status=2;
  }
  if(Ncollect >= SizeW) {
    cout << "MuDbNesl::Add - Ncollect= " << Ncollect;
    cout << " SizeW= " << SizeW << " is NOT enough" << endl;
    return 42;
  }

// pointers
  int* pkey=ElIntW+Ncollect*NelInt;
  float* elfl=ElFlW+Ncollect*NelFloat;
  char*  elch=ElChW+Ncollect*NelChar;

// add the integers
  *pkey=pnesl->neslkey;
  *(pkey+1)=pnesl->inesl;
  *(pkey+2)=pnesl->cmp;
  *(pkey+3)=pnesl->shp;
  *(pkey+4)=pnesl->nsl;
  *(pkey+5)=pnesl->mfl;
  *(pkey+6)=pnesl->lay;
  *(pkey+7)=pnesl->npl;
  *(pkey+8)=pnesl->fpl;
  *(pkey+9)=pnesl->nwl;
  *(pkey+10)=pnesl->fwl;
  *(pkey+11)=pnesl->ltyp;
  *(pkey+12)=pnesl->pnsl;
  for(int j=0; j<6; j++) *(pkey+j+13)=pnesl->chamb[j];
  for(int j=0; j<6; j++) *(pkey+j+19)=pnesl->nx99[j];

// add the floats
  *(elfl)  =pnesl->x1;
  *(elfl+1)=pnesl->x2;
  *(elfl+2)=pnesl->y1;
  *(elfl+3)=pnesl->y2;
  *(elfl+4)=pnesl->z1;
  *(elfl+5)=pnesl->z2;
  *(elfl+6)=pnesl->dx;
  *(elfl+7)=pnesl->dy;

// add the characters
  char nam[5];
  strncpy(&nam[0],&(pnesl->name[0]),5);
  nam[4]='\0';
  strncpy(elch,&nam[0],5);

  Ncollect += 1;
  return 0;
}
