
// Boris Fominykh  4.01.2000
// member functions of class MuPixChamber

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

#include "murec/MuPixChamber.h"

//** Constructor */
MuPixChamber::MuPixChamber()
{
  Clear();
  PixHole();  
  PixConn();  
}

//** Destructor */
MuPixChamber::~MuPixChamber()
{
}

//## Methods
void MuPixChamber::Clear()
{
  for(Word sl=0; sl<Sl; sl++) {
    NxC[sl]=0;
    NxM[sl]=0;
    NyC[sl]=0;
    NyM[sl]=0;
    for(Word nc=0; nc<Ncon; nc++) {
      for(Word nb=0; nb<Nbit; nb++) {
        Pnx1[sl][nc][nb] = 0;
        Pny1[sl][nc][nb] = 0;
      }
    }
    for(Word ny=0; ny<Ny; ny++) {
      NpixHole[sl][ny]=0;
    }
  }
  return;
}

void MuPixChamber::PixHole()
{
// max number of non-connected pixels in x and y directions
// and a number of pixels connected into one readout channel
// MU1,2 
  for(int sl=0; sl<2; sl++) {
    NxM[sl] = 45;
     NyM[sl] = 34;
      NxC[sl] = 2;
       NyC[sl] = 2;
  }
// MU3
  NxM[2] = 45;
   NyM[2] = 34;
    NxC[2] = 1;
     NyC[2] = 4;
// MU4
  NxM[3] = 48;
   NyM[3] = 36;
    NxC[3] = 1;
     NyC[3] = 4;

// pixel chamber structure to describe a hole - number of
// readout channels in x-direction for one y row
// MU1,2 - low density option
  for(int sl=0; sl<2; sl++) {
    NpixHole[sl][0]  = 14;
     NpixHole[sl][1]  = 14;
      NpixHole[sl][2]  = 14;
       NpixHole[sl][3]  = 14;
        NpixHole[sl][4]  = 15;
         NpixHole[sl][5]  = 15;
          NpixHole[sl][6]  = 16;
           NpixHole[sl][7]  = 18;
            NpixHole[sl][8]  = 20;
             NpixHole[sl][9]  = 23;
              NpixHole[sl][10] = 23;
               NpixHole[sl][11] = 23;
                NpixHole[sl][12] = 23;
                 NpixHole[sl][13] = 23;
                  NpixHole[sl][14] = 23;
                   NpixHole[sl][15] = 23;
                    NpixHole[sl][16] = 23;
  }
// MU3
  NpixHole[2][0]  = 27;
   NpixHole[2][1]  = 28;
    NpixHole[2][2]  = 32;
     NpixHole[2][3]  = 40;
      NpixHole[2][4]  = 45;
       NpixHole[2][5]  = 45;
        NpixHole[2][6]  = 45;
         NpixHole[2][7]  = 45;
// MU4
  NpixHole[3][0]  = 30;
   NpixHole[3][1]  = 31;
    NpixHole[3][2]  = 33;
     NpixHole[3][3]  = 38;
      NpixHole[3][4]  = 48;
       NpixHole[3][5]  = 48;
        NpixHole[3][6]  = 48;
         NpixHole[3][7]  = 48;
          NpixHole[3][8]  = 48;
  return;
}

void MuPixChamber::PixConn()
{
// MU1,2 - low density option
  Word nc = 0;
  for(Word sl=0; sl<2; sl++) {
// connector 1
    nc = 0;
    for(Word i=0; i<8; i++) {
      Pnx1[sl][nc][2*i] = 1;
      Pny1[sl][nc][2*i] = 17-i;
    }
// connector 4
    nc = 3;
    Pnx1[sl][nc][0] = 5;
    Pnx1[sl][nc][1] = 4;

    Pny1[sl][nc][0] = 9;
    Pny1[sl][nc][1] = 9;
// connector 6
    nc = 5;
    Pnx1[sl][nc][0] = 7;
    Pnx1[sl][nc][1] = 6;
    Pnx1[sl][nc][2] = 7;
    Pnx1[sl][nc][3] = 6;

    Pny1[sl][nc][0] = 9;
    Pny1[sl][nc][1] = 9;
    Pny1[sl][nc][2] = 8;
    Pny1[sl][nc][3] = 8;
// connector 8
    nc = 7;
    for(Word i=0; i<7; i++) {
      Pnx1[sl][nc][i] = 9-i%2;
      Pny1[sl][nc][i] = 9-i/2;
    }
    Pnx1[sl][nc][8] = 9;
    Pny1[sl][nc][8] = 5;
// connector 18
    nc = 17;
    for(Word i=0; i<14; i++) {
      Pnx1[sl][nc][i] = 10+i;
      Pny1[sl][nc][i] = 1;
    }
// connectors 3,5,7,9,11,13,15,17,19,21,23
    Word r1=17;
    Word c1=0;      
    for(Word nc=2; nc<23; nc+=2) {
      c1=nc+1;      
      for(Word i=0; i<16; i++) {
        Pnx1[sl][nc][i] = c1-i%2;
        Pny1[sl][nc][i] = r1-i/2;
      }
    }
// connectors 10,12,14,16,20,22,24
    r1=9;
    for(Word nc=9; nc<24; nc+=2) {
      if(nc != 17) { 
        if(nc < 17) c1=nc+2;
        else c1=nc;
        for(Word i=0; i<16; i++) {
          Pnx1[sl][nc][i] = c1-i%2;
          Pny1[sl][nc][i] = r1-i/2;
        }
      }
    }
  }
 
// MU3
  Word sl=2;
// connector 2
  nc = 1;
  for(Word i=0; i<4; i++) {
    Pnx1[sl][nc][2*i+1] = 1;
    Pny1[sl][nc][2*i+1] = 8-i;
  }
// connectors 3 - 24
  Word r1=8;
  Word c1=0;      
  int chm = 0;
  for(Word nc=2; nc<24; nc++) {
    c1=2*nc-1;      
    if(nc > 1 && nc < 4)  chm=8;
    if(nc > 3 && nc < 8)  chm=10;
    if(nc > 7 && nc < 10) chm=12;
    if(nc == 10)          chm=15;
    if(nc > 10)           chm=16;
    for(Word i=0; i<chm; i++) {
      Pnx1[sl][nc][i] = c1-i%2;
      Pny1[sl][nc][i] = r1-i/2;
    }
  }
// MU4
  sl=3;
// connectors 1 - 24
  r1=9;
  for(Word nc=0; nc<24; nc++) {
    c1=2*nc+2;      
    if(nc < 5)            chm=10;
    if(nc > 4 && nc < 7)  chm=12;
    if(nc == 7)           chm=13;
    if(nc == 8)           chm=15;
    if(nc > 8)            chm=16;
    for(Word i=0; i<chm; i++) {
      Pnx1[sl][nc][i] = c1-i%2;
      Pny1[sl][nc][i] = r1-i/2;
    }
  }

  for(Word nc=0; nc<6; nc++) {
    if(nc < 3) {
      Pnx1[sl][nc][10] = 20+nc*2;
      Pnx1[sl][nc][11] = 19+nc*2;
    }
    Pnx1[sl][nc][12] = 38+nc*2;
    Pnx1[sl][nc][13] = 37+nc*2;
    Pnx1[sl][nc][14] = 26+nc*2;
    Pnx1[sl][nc][15] = 25+nc*2;

    for(Word i=10; i<16; i++) {
      if(nc < 3 || (nc > 2 && i > 11)) { 
        Pny1[sl][nc][i] = 1;
      }
    }
  }
}

void MuPixChamber::Print()
{
// create the log-file and pipe the programm output
  ofstream fout("MuPixChamber.out");
  if (!fout) {
    cout << "MuPixChamber - can NOT open file for print" << endl;
    return;
  }

  fout << "MuPixChamber:" << endl;
  for(Word sl=0; sl<Sl; sl++) {
    fout << "pixel chamber sl " << dec << sl;
    fout << " Npix X " << NxM[sl] << " con " << NxC[sl];
    fout << " Npix Y " << NyM[sl] << " con " << NyC[sl];
    fout << endl; 
    for(Word ny=0; ny<Ny; ny++) {
      fout << "Ny: " << ny << " NchanX: " << NpixHole[sl][ny] << endl;
    }
    for(Word nc=0; nc<Ncon; nc++) {
      fout << "connector " << dec << nc << " :" << endl;
      for(Word nb=0; nb<Nbit; nb++) {
        fout << "   bit " << nb << " pix ";
        fout << Pnx1[sl][nc][nb] << " - " << Pny1[sl][nc][nb];
        if((nb+1)%4 == 0) fout << endl;
      }
      fout << endl;
    }
  }
}
 
