#ifndef MuDbPad_h
#define MuDbPad_h 1

//## Class: MuDbPad
//      /**Author:        Boris Fominykh
//
//      Date:             December 29, 1999
//
//      Class:            MuDbPad
//
//      Base Class:       MuDbChamber
//
//      Description:
//      This class is to describe the configuration of muon pad chambers,
//      This class can be used without ARTE. */

#include "murec/MuDbNesl.h"
#include "murec/MuDbNede.h"
#include "murec/MuDbConfig.h"
#include "murec/MuDbHots.h"
#include "murec/MuDbChamber.h"

typedef unsigned int   LWord;
typedef unsigned short Word;

class MuDbPad:  public MuDbChamber
{
  public:
    //## Constructor
           MuDbPad();
    //## Destructor
           ~MuDbPad();

    //public methods
      //        /** Clear the object */
      void Clear();
      //        /** Set the cable connection */
      int SetConnect();
      //        /** Initialization */
      int Ini();
      //        /**Print the contents of the object*/
      void Print();

    int Ivalid;
    static const Word PadGeoSl     = 2;
    static const Word PadGeoUpDown = 2;
    static const Word PadGeoCh     = 34;
    static const Word PadGeoSd     = 2;
    static const Word PadGeoRow    = 2;
    static const Word Nconn        = 2;
    static const Word NconP        = 4;

//## number of pad chambers
    Word NchambP[PadGeoSl][PadGeoUpDown];
//## number of wires in the pad chamber
    Word PadGeoWire;
//## number of pads per row
    Word Npads[PadGeoSl][PadGeoUpDown][PadGeoCh];
//## gede
    LWord PadGede[PadGeoSl][PadGeoUpDown][PadGeoCh][PadGeoSd];
//## chamber names
    char ChamListP[PadGeoSl][PadGeoUpDown][PadGeoCh][9];

//## number of connected wires by half-connector
    static const Word  NumbT = 8;
//## number of tube readout half-connectors per chamber
    Word NconnP[PadGeoSl][PadGeoUpDown][PadGeoCh];
//## tube readout mask
    Word  MaskP[PadGeoSl][PadGeoUpDown][PadGeoCh][Nconn];
//## first connected wire
    Word  Wire1P[PadGeoSl][PadGeoUpDown][PadGeoCh][Nconn][PadGeoSd];
//## first bit inside crate
    Word  Nbit1P[PadGeoSl][PadGeoUpDown][PadGeoCh][Nconn][PadGeoSd];
//## crate for wire readout
    Word  CrateP[PadGeoSl][PadGeoUpDown][PadGeoCh];
//## step for wire readout(+2 or -2)
    int  StepP[PadGeoSl][PadGeoUpDown][PadGeoCh];

//## number of pad readout connectors per chamber
    Word NconPP[PadGeoSl][PadGeoUpDown][PadGeoCh];
//## pad readout mask
    Word  MaskPP[PadGeoSl][PadGeoUpDown][PadGeoCh][NconP];
//## first connected pad
    Word  Pad1[PadGeoSl][PadGeoUpDown][PadGeoCh][NconP];
//## number of connected pads per connector
    Word  NumbP[PadGeoSl][PadGeoUpDown][PadGeoCh][NconP];
//## first bit inside crate
    Word  Nbit1PP[PadGeoSl][PadGeoUpDown][PadGeoCh][NconP];
//## crate number
    Word  CratePP[PadGeoSl][PadGeoUpDown][PadGeoCh];

  protected:

  private:

      //        /** Set the tube chamber structure */
      int SetStruct();
};

#endif
