*-- Author :    Rainer Mankel   08/11/93

      subroutine di1rtra(rt,islsta,islend,chopt)

*     **** display reconstructed tracks
      implicit none
#include "pris/zgraf.fi"
#include "arte/Arte.fi"
      integer max_graf
      parameter (max_graf=200)
      integer rt, rh, ngraf, islsta, islend, isl, ipl, i_sort, n_sort,
     +     rh_sort(max_graf), iirh, indx_rhit,
     +     rp, iirp, indx_rpnt, smk, rr, rv, rcl, diident, gcode,
     +     ierror,ii

      real wh(5), xxx(max_graf), yyy(max_graf), sna, zzz(max_graf),
     +     ltyp, lwid, txci, oin(max_graf), dz,zmax

      double precision z_in,z_out,p_in(5),p_out(5),rkd(5,5)

      character*(*) chopt
      logical lplus, lzero, lplsup, spl
      character*2 opt_c, opt_l
      character*10 cnpart
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/RREL.fi"
#include "auto/RVER.fi"
#include "auto/RPNT.fi"
#include "auto/RCCL.fi"
#include "auto/HITB.fi"
#include "auto/GESL.fi"
#include "auto/GEDE.fi"

      integer maxgcode
      parameter (maxgcode=60)
      character*8 cn(maxgcode)
      data cn / '[g]','e^+!','e^-!',' ','[m]^+!',
     +     '[m]^-!',' ','[p]^+!','[p]^-!','K^0!?L!',
     +     'K^+!','K^-!','n','p','p&^-!',
     +     'K^0!?S!',4*' ',
     +     4*' ','n&^-!',
     +     5*' ',
     +     2*' ','[t]^+!','[t]^-!','D^+!',
     +     'D^-!','D^0!','D&_^0','D?s!^+!','D?s!^-!',
     +     5*' ',
     +     3*' ','J/[y]',' ',
     +     'B^+!','B^-!','B^0!','B&_^0','B?s!',
     +     'B&_?s!',4*' '/
      save cn

#include "arte/Arte.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/RREL.ff"
#include "auto/RVER.ff"
#include "auto/RPNT.ff"
#include "auto/RCCL.ff"
#include "auto/HITB.ff"
#include "auto/GESL.ff"
#include "auto/GEDE.ff"

*     **** stereo mode option
      lplus = index(chopt,'Y').gt.0
      lzero = index(chopt,'0').gt.0
      lplsup = lplus.or.lzero

*     **** ghosts option
      if (index(chopt,'U').gt.0) then
       if (prtra_mtra(rt).gt.0) go to 999
      endif

*     **** colour index
      call igset('PLCI',corczg)
      call igset('PMCI',corczg)
      call igset('LTYP',1.)
      call igset('LWID',6.)

      n_sort = 0

*     **** locate vertex
      if (lrverzg.and.iviewzg.ne.11) then
         if (prtra_rrel(rt).gt.0) then
            rr = mrtra_rrel(prtra_rrel(rt))
            if (rr.gt.0) then
               rv = orrel_rver(rr)
#ifdef FULL
               print *,' vertex for rt=',rt,' is ',rv
#endif
               if (xrtra_rrel(rr).ne.0) then
                  print *,' di1rtra: more than 1 vertex for rt=',
     +                 rt
               endif
               if (n_sort.lt.max_graf) then
                  n_sort = n_sort + 1
#ifndef NOCONSTRAINT
                  wh(1) = frver_xv(rv)
                  wh(2) = frver_yv(rv)
                  wh(3) = frver_zv(rv)
#else
                  wh(1) = frtra_xf(rt)
     +                 + (frver_zv(rv)-frtra_zf(rt)-.1) * frtra_txf(rt)
                  wh(2) = frtra_yf(rt)
     +                 + (frver_zv(rv)-frtra_zf(rt)-.1) * frtra_tyf(rt)
                  wh(3) = frver_zv(rv)-.1
#endif
                  wh(4) = 0.
                  wh(5) = 0.
                  call dipro5(wh,xxx(n_sort),yyy(n_sort))
                  zzz(n_sort) = wh(3)
               endif
            else
               print *,' () di1rtra: overflowing n_sort=', n_sort
               stop 'di1rtra'
            endif
         endif
      endif




*     **** loop over reconstructed hits
      if (jrhit.gt.0) then
         do 10 rh=1,iq(jrhit+2)
            if (irhit_rtra(rh).ne.rt) go to 10
            if (index(chopt,'L').gt.0)
     +           print *,' di1rtra: display RHIT=', rh
            ipl = ihitb_gede(orhit_hitb(rh))
            isl = ogede_gesl(ipl)
            if (isl.lt.islsta.or.isl.gt.islend) go to 10
            if (modezg.eq.1) then
               if (isl.gt.scmxzg) go to 10
               if (.not.lscopzg(isl)) go to 10
            endif

*     **** check plane
            if (lplsup) then
               sna = abs( fgede_sin(ipl) )
               if (sna.gt.1.e-10.and.lzero) go to 10
               if (sna.le.1.e-10.and.lplus) go to 10
            endif

            if (n_sort.lt.max_graf) then
               n_sort = n_sort + 1
               wh(1) = frhit_x(rh)
               wh(2) = frhit_y(rh)
               wh(3) = fhitb_z(orhit_hitb(rh))
               wh(4) = atan(frhit_tx(rh))
               wh(5) = atan(frhit_ty(rh))
               call dipro5(wh,xxx(n_sort),yyy(n_sort))
               zzz(n_sort) = wh(3)
            else
               print *,' () di1rtra: overflowing n_sort=', n_sort
               go to 11
            endif
 10      continue
 11      continue
      else  ! if not RHIT table available
         if (mod(irtra_fit(rt),10).eq.0
     +        .or.mod(irtra_fit(rt),10).eq.1) then
            zmax = frtra_zf(rt)
*           **** the following estimation of zmax is clearly a
*           **** makeshift solution and should be replaced
*           **** as soon as zmax is available from RTRA table
            if (irtra_hsi(rt).gt.0) zmax = 205.
            if ((irtra_hou(rt)+irtra_hin(rt)).gt.0) zmax = 1330.
            if (irtra_hmu(rt).gt.0) zmax = 2000.
            
            if (zmax.gt.frtra_zf(rt)) then
               dz = (zmax - frtra_zf(rt)) / 100
               z_in = frtra_zf(rt)
               p_in(1) = frtra_xf(rt)
               p_in(2) = frtra_yf(rt)
               p_in(3) = frtra_txf(rt)
               p_in(4) = frtra_tyf(rt)
               p_in(5) = frtra_pf(rt)

               do 40 iirp=1,100
                  z_out = frtra_zf(rt) + (iirp-0.5) * dz
                  call rktrans(z_in,p_in,z_out,p_out,rkd,ierror)
                  if (ierror.gt.0) go to 41
                  if (n_sort.lt.max_graf) then
                     n_sort = n_sort + 1
                     wh(1) = p_out(1)
                     wh(2) = p_out(2)
                     wh(3) = z_out
                     wh(4) = atan(sngl(p_out(3)))
                     wh(5) = atan(sngl(p_out(4)))
                     call dipro5(wh,xxx(n_sort),yyy(n_sort))
                     zzz(n_sort) = wh(3)
                     do ii=1,5
                        p_in(ii) = p_out(ii)
                     enddo
                     z_in = z_out
                  else
                     print *,' () di1rtra: overflowing n_sort (2)=', 
     +                    n_sort
                     go to 41
                  endif

                  
 40            continue
 41            continue
            endif               ! zmax gt
         endif                  ! fit
      endif                     ! rhit avail

#ifdef RPNT
*     **** loop over reconstructed points
      do 20 iirp=1,999
         if (iirp.eq.1) then
            indx_rpnt = prtra_rpnt(rt)
         else
            indx_rpnt = xrtra_rpnt(indx_rpnt)
         endif
         if (indx_rpnt.le.0) go to 21
         rp = mrtra_rpnt(indx_rpnt)
         if (index(chopt,'L').gt.0)
     +        print *,' di1rtra: display RPNT=', rp
#ifdef LATER
         if (isl.lt.islsta.or.isl.gt.islend) go to 20
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 20
            if (.not.lscopzg(isl)) go to 20
         endif

*        **** check plane
         if (lplsup) then
            sna = abs( fgede_sin(ipl))
            if (sna.gt.1.e-10.and.lzero) go to 20
            if (sna.le.1.e-10.and.lplus) go to 20
         endif
#endif

         if (n_sort.lt.max_graf) then
            n_sort = n_sort + 1
            zzz(n_sort) = frpnt_zf(rp)
            wh(1) = frpnt_xf(rp) ! 3D point from RPNT
            wh(2) = frpnt_yf(rp)
            wh(3) = frpnt_zf(rp)
            wh(4) = atan(frpnt_txf(rp))
            wh(5) = atan(frpnt_tyf(rp))
            call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
         else
            print *,' () di1rtra: overflowing n_sort=', n_sort
            stop 'di1rtra'
         endif
 20   continue
 21   continue
#endif

*     **** for photons, extrapolate 1st point
      if (lneutzg.and.irtra_fit(rt).eq.6) then
         if (n_sort.lt.max_graf) then
            n_sort = n_sort + 1
            zzz(n_sort) = 0.
            wh(1) = frtra_xf(rt) 
     +           + frtra_txf(rt) * (zzz(n_sort) - frtra_zf(rt))
            wh(2) = frtra_yf(rt) 
     +           + frtra_tyf(rt) * (zzz(n_sort) - frtra_zf(rt))
            wh(3) = zzz(n_sort)
            wh(4) = frtra_txf(rt)
            wh(5) = frtra_tyf(rt)
            call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
         else
            print *,' () di1rtra: overflowing n_sort=', n_sort
            return
         endif
      endif
         

*     **** locate associated cluster
      if (jrccl.gt.0) then
         if (prtra_rccl(rt).gt.0) then
            rcl = mrtra_rccl(prtra_rccl(rt))
            if (n_sort.lt.max_graf) then
               n_sort = n_sort + 1
               zzz(n_sort) = frccl_z(rcl)
               wh(1) = frccl_x(rcl) ! 3D point from RCCL
               wh(2) = frccl_y(rcl)
               wh(3) = frccl_z(rcl)
               wh(4) = atan(frccl_tx(rcl))
               wh(5) = atan(frccl_ty(rcl))
               call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
            else
               print *,' () di1rtra: overflowing n_sort=', n_sort
               return
            endif
         endif
      endif
            

*     **** draw the graph
      if (lcrosszg) then
         call ismk(28)          ! set marker type
         call ismksc(1.5)       ! marker scale factor
         opt_l = 'LP'
         opt_c = 'CP'
      else
         opt_l = 'L'
         opt_c = 'C'
      endif


      lwid = widrczg
      spl = lsplinezg.and.abs(frtra_pf(rt)).gt.1
      txci = corczg

      cnpart = ' '

      if (ltypezg) then         ! particle label option
         gcode = diident(rt)
         if (gcode.ge.1.and.gcode.le.maxgcode) then
            cnpart = cn(gcode)
         endif
      endif

      smk = 0
      if (lcrosszg) smk = 28

      if (irtra_fit(rt).ne.6) then
         ltyp = 1.
      else
         ltyp = 12.
      endif

      call igset('LTYP',ltyp)

      call ditraj(n_sort,xxx,yyy,zzz,zzz,lwid,ltyp,spl,.true.,
     +     .true.,smk,txci,cnpart)

*     **** draw RPNT markers
      if (lrpntzg) then
         n_sort = 0
         do 30 iirp=1,999
            if (iirp.eq.1) then
               indx_rpnt = prtra_rpnt(rt)
            else
               indx_rpnt = xrtra_rpnt(indx_rpnt)
            endif
            if (indx_rpnt.le.0) go to 31
            rp = mrtra_rpnt(indx_rpnt)

            if (n_sort.lt.max_graf) then
               n_sort = n_sort + 1
               zzz(n_sort) = frpnt_zf(rp)
               wh(1) = frpnt_xf(rp) ! 3D point from RPNT
               wh(2) = frpnt_yf(rp)
               wh(3) = frpnt_zf(rp)
               wh(4) = atan(frpnt_txf(rp))
               wh(5) = atan(frpnt_tyf(rp))
               call dipro5(wh,xxx(n_sort),yyy(n_sort)) ! projection
               call ismk(24)    ! set marker type
               call ismksc(3.0) ! marker scale factor
               call ipm(1,xxx(n_sort),yyy(n_sort))
            else
               print *,' () di1rtra: overflowing n_sort=', n_sort
               stop 'di1rtra'
            endif
 30      continue
 31      continue
      endif

 999  end


