/* Classes describing non geometrical information of High-Pt system.
   The resulting Setup classes are:
      HPT_Cell;
      HPT_Section;
      HPT_Chamber;
      HPT_Setup;
      */

// Author V.Balagura (balagura@mail.desy.de)   (09.04.98).

#ifndef _high_pt_hh
#define _high_pt_hh 1

#include "ptset/setup.hh"
#include "ptset/dummy.hh"
#include "ptset/fired_cells.hh"
//#include "ptset/global_error.hh"

class HPT_CellT : public Fired_Cell {
public:
  /*
  struct DataType {
    unsigned char tdc;
    friend istream& operator>>(istream& is, DataType& x) {
      unsigned int i;
      if ( !(is >> i) ) global_error()("can not read TDC value");
      else if ( i >= 256 ) {
	string tmp;
	tmp << "TDC value is out of range: " << i;
	global_error()(tmp);
      }
      else x.tdc = (unsigned char)i;
      return is; 
    }      
    friend ostream& operator>>(ostream& os, const DataType& x) {
      return os << int(x.tdc);
    }      
  };
  */
  typedef bool DataType;
  DataType data;
  //  bool is_fired() { return data.tdc != 255; }
  bool is_fired() { return data; }
};
struct HPT_SetupT {
  static const string& setup_type() { 
    static string x("high-pt"); return x; 
  }
};  
// typedef Section_With_Fired_Cells<HPT_CellT> HPT_SectionT;
struct HPT_SectionT : public Section_With_Fired_Cells<HPT_CellT> {};

typedef SetupCell<HPT_CellT>                                 HPT_Cell;
typedef SetupSection<HPT_CellT, HPT_SectionT>                HPT_Section;
typedef SetupChamber<HPT_CellT, HPT_SectionT, Dummy>         HPT_Chamber;
typedef Setup<HPT_CellT, HPT_SectionT, Dummy, HPT_SetupT>    HPT_Setup;

/*
struct HPT_Cell : public SetupCell<HPT_CellT> {
  HPT_Cell() {}
  HPT_Cell(const SetupCell<HPT_CellT>& x) : SetupCell<HPT_CellT>(x) {}
  HPT_Cell& operator=(const SetupCell<HPT_CellT>& x) { 
    *((SetupCell<HPT_CellT>*)this) = x;
    return *this;
  }
};
struct HPT_Section : public SetupSection<HPT_CellT, HPT_SectionT> {
  HPT_Section() {}
  HPT_Section(const SetupSection<HPT_CellT, HPT_SectionT>& x) 
    : SetupSection<HPT_CellT, HPT_SectionT>(x) {}
  HPT_Section& operator=(const SetupSection<HPT_CellT, HPT_SectionT>& x) { 
    *((SetupSection<HPT_CellT, HPT_SectionT>*)this) = x;
    return *this;
  }
};
struct HPT_Chamber : public SetupChamber<HPT_CellT, HPT_SectionT, Dummy> {
  HPT_Chamber() {}
  HPT_Chamber(const SetupChamber<HPT_CellT, HPT_SectionT, Dummy>& x)
    : SetupChamber<HPT_CellT, HPT_SectionT, Dummy>(x) {}
  HPT_Chamber& operator=(const SetupChamber<HPT_CellT,
			 HPT_SectionT, Dummy>& x) { 
    *((SetupChamber<HPT_CellT, HPT_SectionT, Dummy>*)this) = x;
    return *this;
  }
};
struct HPT_Setup : public Setup<HPT_CellT, HPT_SectionT, Dummy, HPT_SetupT> {
  typedef HPT_Cell    Cell;
  typedef HPT_Section Section;
  typedef HPT_Chamber Chamber;
};
*/
#endif
