// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerThickWall
// node class for extended multiple scattering object based on wall

#ifndef rangerThickWall_HH
#define rangerThickWall_HH

#include "arte/arte.hh"
#include "rang/Node.hh"
#include "rang/Thick.hh"
#include "rang/Volume.hh"

class rangerThickWall : public rangerThick {

public:

  rangerThickWall();
  rangerThickWall(const ArtePointer<GWAL>& gw,rangerNode* n);
  rangerThickWall(const ArtePointer<GWAL>& gw,rangerNode* n,const float path);
  virtual ~rangerThickWall(){};   // virtual destructor
  
  inline float ms() const {return sPath*vol->ms();}
  inline float msPlain() const { return sPath*gwal->ms; }
  inline float dz(){return (gwal->zmax - gwal->zmin);}
  inline int plane(){return -gwal.index();}

protected:

private:
  ArtePointer<GWAL> gwal;
  rangerVolume* vol;
  float sPath;
};

#endif
