*-- Author :    Rainer Mankel   22/05/96
*-- changed:    A. Spiridonov   03/11/99

#define NEWNAV
#define Y_DUPLICATE
#define Y_TARGET

#ifdef NEWNAV
      subroutine tfpropcyn(clus1,clus2,direction)
#else
      subroutine tfpropcy(clus1,clus2,direction)
#endif

*     **** propagate vertical clusters clus1...clus2 in /ztripl/
*     **** direction=-1 means backwards
      implicit none
#include "rang/ztripl.fi"
#include "arte/Arte.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zplx.fi"

#ifdef NEWNAV
      integer rgxproft
      double precision rgxproqpt
#ifdef Y_TARGET
      real x_old,tx_old
      real y_targ,z_targ,w_targ,ty_targ,dty_targ_clus
      parameter (y_targ = 0.)
      parameter (z_targ = 0.)
      parameter (w_targ = 0.0025)
      parameter (dty_targ_clus = 0.15)
#endif
#else
#include "rang/zdomain.fi"
#endif
      integer maxhit
      parameter (maxhit=1000)
      integer clus,nhit,itrip,trip,ii,ind_hs(maxhit),n_unique,set,izf,
     +     lasthit,ift,nca_x,direction,clus1,clus2,pl,nstring,way
      integer message_id_1
      real w(maxhit),wtot,sx,sy,sxx,sxy,zref,x,tx,d,tfqptest,sn,
     +     sintot
      integer zfstart
      character*500 cstring

#ifdef Y_DUPLICATE
      integer ind_hs_1(maxhit)
#endif

      integer kk

#include "auto/GEO.fi"
#include "auto/HITB.fi"
      
      data message_id_1/1/
      save message_id_1

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      if (diag_level.ge.3) then
         print *,' tfpropcyn: propagating clusters ', clus1,' to ',
     +        clus2, ' direction ', direction
      endif

      nca_x = nca_ft

      do 12 clus=clus1,clus2
         nhit = 0
         do 20 itrip=1,999      ! collect triplets
            if (itrip.eq.1) then
               trip = trip1_clus(clus)
            else
               trip = nx_trip(trip)
            endif
            if (trip.eq.0) go to 21
            if (nhit.eq.100) print *,' () tfpropcy: nhit exceeding',
     +           ' 100, clus=', clus,' mult=', mult_clus(clus)
            if (nhit.gt.(maxhit-3)) then
               print *,' () tfpropcy: overflowing nhit=', nhit
               print *,'    discard cluster ', clus,
     +              ' mult=', mult_clus(clus)
               go to 999
            endif
            do ii=1,3
               nhit = nhit + 1
               ind_hs(nhit) = s_trip(ii,trip)
            enddo
 20      continue
 21      continue

         if ((n_zf + nhit).gt.nzfmx) then
            call mepric(message_id_1,3,
     +           'tfpropcy: ranger buffer at limit, clusters aborted')
            go to 11
         endif

         if (direction.eq.1) then
            way = 0
         elseif (direction.eq.-1) then
            way = 1
         else
            print *,' () tfpropcy: invalid direction=', direction
         endif

         call sortzv(z_set,ind_hs,nhit,+1,way,1) ! sort decr z

#ifndef Y_DUPLICATE
         lasthit = 0
         n_unique = 0
         do ii=1,nhit           ! clean up the duplicates
            set = ind_hs(ii)
            if (hit_set(set).ne.lasthit) then
               n_unique = n_unique + 1
               ind_hs(n_unique) = set
               lasthit = hit_set(set)
            endif
         enddo
#else
        n_unique = 0
        do 10 ii=1,nhit              ! clean up the duplicates
          set = ind_hs(ii)
          if(n_unique.gt.0) then
            do lasthit=1,n_unique
              if(hit_set(ind_hs_1(lasthit)).eq.hit_set(set)) go to 10 !skip hit
            end do
            n_unique = n_unique + 1
            ind_hs_1(n_unique) = set
          else                                                   ! n_unique = 0
            n_unique = n_unique + 1
            ind_hs_1(n_unique) = set
          endif   
 10          continue
        do ii=1,n_unique
          ind_hs(ii) = ind_hs_1(ii)
        end do
#endif
         nhit = n_unique
         if (n_unique.gt.100) then
            print *,' () tfpropcy: n_unique=',
     +        n_unique,' skip cluster ',clus
            go to 999
         endif
*         print *,(hit_set(ind_hs(kk)),kk=1,nhit)

         zref = z_set(ind_hs(nhit))
         wtot = 0.
         sx = 0.
         sy = 0.
         sxy = 0.
         sxx = 0.

         zfstart = n_zf

         do ii=1,nhit           ! linear regression
            set = ind_hs(ii)
            pl = ihitb_gede(hit_set(set))
            sn = sntot_plx(pl)
**            if (igede_cmp(pl).eq.1.or.igede_cmp(pl).eq.3) then
**               sn = fgede_rot(2,pl)
**            elseif (igede_cmp(pl).eq.2) then
**               sn = fgede_sin(pl)
**            else
**               print *,' () tfpropcy: invalid cmp=',
**     +              ihitb_gede(hit_set(set))
**            endif
            w(ii) = sn**2 / fhitb_r( hit_set(set) )**2

**            print '(" tfpropcyn : ii,sn,hitb_r,w(ii)=",i4,3(1x,f8.3))'
**     +             ,ii,sn,fhitb_r( hit_set(set) ),w(ii)

            if (fhitb_r( hit_set(set) ).le.0.)
     +           print *,' () tfpropcy: r=', fhitb_r( hit_set(set) )
            wtot = wtot + w(ii)
            sx = sx + w(ii) * (z_set(set)-zref)
            sy = sy + w(ii) * x_set(set)
            sxy = sxy + w(ii) * (z_set(set)-zref) * x_set(set)
            sxx = sxx + w(ii) * (z_set(set)-zref)**2

**            print *,' ii,x,z,zref,w=',ii,x_set(set),z_set(set),zref,w(ii)

            if (n_zf.ge.nzfmx) then
               print *,' () tfpropcy: overflowing n_zf=',n_zf
               go to 999
            endif
            n_zf = n_zf + 1
            hit_zf(n_zf)   = hit_set(set)
            nhit_zf(n_zf)  = ii
            whit_zf(n_zf)  = ii
            plane_zf(n_zf) = ihitb_gede(hit_set(set))
            sintot = fgede_sin(plane_zf(n_zf))
     +           * fgede_rot(1,plane_zf(n_zf))
     +           + fgede_cos(plane_zf(n_zf))
     +           * fgede_rot(2,plane_zf(n_zf))
            z_zf(n_zf) = fhitb_z(hit_set(set))
            ch_zf(n_zf) = 0.
            cht_zf(n_zf) = 0.
**            if (sintot.gt.0.) then
**               sign_zf(n_zf) = -sig_set(set)
**            else
**               sign_zf(n_zf) = +sig_set(set)
**            endif
            sign_zf(n_zf) = sig_set(set)
            domlay_zf(n_zf) = dl_set(set)
            if (ii.eq.1) then
               prev_zf(n_zf) = 0
            else
               prev_zf(n_zf) = n_zf - 1
            endif
            fault_zf(n_zf) = 0
            pfault_zf(n_zf) = 0
            dim_zf(n_zf) = 1
            shadow_zf(n_zf) = 0
         enddo

         d = wtot * sxx - sx**2
         if (d.eq.0.) print *,' () tfpropcyn: discr=0'

         x  = (sxx * sy - sx * sxy) / d
         tx = (wtot * sxy - sx * sy) / d

#ifdef NEWNAV
#ifdef Y_TARGET

         ty_targ = (x - y_targ) / ( zref - z_targ) 
         if(abs(tx-ty_targ).gt.dty_targ_clus) then
*            print '("tfpropcyn : tx,ty_targ=",2(1x,f8.3),"   REJECTED")'
*     +            ,tx,ty_targ
            go to 12                           !  skip cluster
            else
*            print '("tfpropcyn : tx,ty_targ=",2(1x,f8.3),"   ACCEPTED")'
*     +            ,tx,ty_targ
         endif

         x_old = x
         tx_old = tx

         wtot = wtot + w_targ
         sx = sx + w_targ * (z_targ - zref)
         sy = sy + w_targ * y_targ
         sxy = sxy + w_targ * (z_targ - zref) * y_targ
         sxx = sxx + sxx + w_targ * (z_targ - zref) ** 2

         d = wtot * sxx - sx**2
         if (d.eq.0.) print *,' () tfpropcyn: discr=0'
 
         x  = (sxx * sy - sx * sxy) / d
         tx = (wtot * sxy - sx * sy) / d

*         print '(" tfpropcyn : xo,x,txo,tx=",4(1x,f8.3))'
*     +          ,x_old,x,tx_old,tx

#endif
#endif

         do izf=zfstart+1,zfstart+nhit
            xx_zf(2,izf) = x + (z_zf(izf)-zref) * tx
            xx_zf(1,izf) = 0.
            xx_zf(4,izf) = tx
            xx_zf(3,izf) = 0.
#ifdef NEWNAV
            xx_zf(5,izf) = rgxproqpt()
#else
            xx_zf(5,izf) = qpt_dlx
#endif
            ch_zf(izf) = w(izf-zfstart) *
     +           (xx_zf(2,izf) - x_set(ind_hs(izf-zfstart)))**2
            if (izf.ne.(zfstart+1)) then
               cht_zf(izf) = cht_zf(izf-1) + ch_zf(izf)
            else
               cht_zf(izf) = ch_zf(izf)
            endif
            ii = izf-zfstart
**            print *,' ii,izf,xx(2,),x_set,w,ch_zf,cht_zf',
**     +           ii,izf,xx_zf(2,izf),x_set(ind_hs(ii)),w(ii),
**     +           ch_zf(izf),
**     +           cht_zf(izf)
         enddo

**         xx_zf(5,n_zf) = tfqptest(fhitb_z(hit_set(ind_hs(nhit))),x,tx)
         cx_zf(2,2,n_zf) = sxx / d
         cx_zf(4,4,n_zf) = wtot / d
         cx_zf(2,4,n_zf) = -sx / d
         cx_zf(4,2,n_zf) = -sx / d


         if (diag_level.ge.4) then
            print *,' track parameters:'
            print '(a6,f10.3,a6,f10.3)',
     +           ' x=',xx_zf(2,n_zf),' +- ', dsqrt( cx_zf(2,2,n_zf) )
            print '(a6,f10.3,a6,f10.3)',
     +           ' tx=',xx_zf(4,n_zf),' +- ', dsqrt(cx_zf(4,4,n_zf))
         endif

*        **** fill candidate info
         nca_ft          = nca_ft + 1
         ift             = nca_ft
         first_ft(ift)   = 1
         last_ft(ift)    = n_zf
#ifdef NEWNAV
         prev_ft(ift)    = rgxproft()
#else
         prev_ft(ift)    = ft_dlx
#endif
         gen_ft(ift)     = nhit
         nhit_ft(ift)    = nhit
         nfault_ft(ift)  = 0
         quality_ft(ift) = nhit - 0.1 * cht_zf(last_ft(ift))
         alive_ft(ift)   = .true.
         mature_ft(ift)  = .false.
         stat_ft(ift)    = 0

         if (diag_level.ge.4) then
            print *,' tfpropcy: cluster', clus, ' stored',
     +           ' n_zf,nca_ft=',n_zf,nca_ft
            call tflft(ift,' ')
            cstring = ' '
            call tfstrg(ift,cstring,nstring)
            print *,' tfpropcy: propagate ', cstring(1:nstring)
         endif
                        
*      enddo                                    ! end do cluster
 12   continue                                 ! end do cluster

 11   continue

*     **** track all seeds simultaneously
      begin_ft = nca_x + 1
      if (diag_level.ge.4) then
         print *,' tfpropcy: propagate cluster ', clus,
     +        ' nhit=', nhit
      endif

      l_2dy = .true.
      l_2dx = .false.
      l_mag = .false.
#ifdef NEWNAV
      call tfpropyn(direction)
#else
      call tfpropy(direction)
#endif

*     **** final killings
      call tfbest()


 999  end
