
// ********************************************************************
//
//  Routine:      rc99AParticleID
//  Author:       T.Oest/D.Samtleben
//
//  Description:  stand alone reconstruction
//
//  Modification:
//   --  RICH particle ID added                     14/09/99  T.Oest
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

#include "reco/rc99Areco.hh"

extern int recoRICH;

int rc99AidRICH(int);

static int recoID  = 0;

//********************************************************************
// rcParticleID
//********************************************************************
  int rc99AParticleID() {

//===================================================================
//  RICH particle ID for electrons
//===================================================================

    if (recoID) int RICHidFlag = rc99AidRICH(recoID) ;

//===================================================================
//  flag for particle ID
//===================================================================

    return 0;

  }


/************************************************************************
* KAPID
*
* called from  KUIP
***********************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
//#include "arte/Arte.hh"

extern "C" void kugetc_( char*, int *, int );


extern "C" void kapid_() {   

//---------------------------------------------------------------
//   read in subdetector
//---------------------------------------------------------------

  int len;        
  int len1 = 4;
  char input[7];
  kugetc_(input, &len, len1);

  char *subdetector;
  subdetector  = (char *) malloc(len+1);
  sprintf(subdetector  ,"%s", input);

  for(int i=0; i<len; i++) subdetector[i] = toupper(subdetector[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 3;
  kugetc_(input, &len, len1);

  char *status;
  status  = (char *) malloc(len+1);
  sprintf(status  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 4;
  kugetc_(input, &len, len1);

  char *module;
  module  = (char *) malloc(len+1);
  sprintf(module  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) module[i] = toupper(input[i]);

//---------------------------------------------------------------
//   set reconstruction status
//---------------------------------------------------------------

  int istatus = !strncmp(status,"ON",2);

  if (!strncmp(subdetector,"RICH"   ,4)) recoID     = istatus;

  if (recoID == 1){
   if (!strncmp(module,"RIRE"   ,4)) recoID     = 2;
  };

  if (!strncmp(subdetector,"ALL" ,3)) {
     recoID      = istatus;
  };

//---------------------------------------------------------------
//   switch on RICH hit preparation if necessary
//---------------------------------------------------------------

  if (recoID !=0) recoRICH = recoRICH | 1;


};
