// ********************************************************************
//
//  Routine:      rc99SelectTracks
//  Author:       T.Oest
//
//  Description:  select tracks from matched segments
//
//  Modification:
//  -- remove Rxxx banks before track selection        01/12/99 T.Oest
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"

void rc99inventRTRA();

int rc99SelectTracksStatus = 0;

//*****************************************************************
// function  
//*****************************************************************

int rc99SelectTracks() {

  int flag = 0;

//==================================================================
// remove tracks and vertices
//==================================================================

  if (rc99SelectTracksStatus == 1) {
     if (ArteTable<RTRA>::size() !=0) ArteTable<RTRA>::clear();
     if (ArteTable<RVER>::size() !=0) ArteTable<RVER>::clear();
     if (ArteTable<RREL>::size() !=0) ArteTable<RREL>::clear();
     if (ArteTable<RPNT>::size() !=0) ArteTable<RPNT>::clear();
  };

//==================================================================
// select VDS/ECAL/RICH tracks
//==================================================================

  if (rc99SelectTracksStatus == 1) rc99inventRTRA();

//==================================================================
  return flag;

};

/************************************************************************
* KARTRA
*
* called from  KUIP
***********************************************************************/
// #include <stdio.h>
#include <string.h>
#include <ctype.h>
// #include "arte/Arte.hh"

extern "C" void kugetc_( char*, int *, int );


extern "C" void kartra_() {   

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  int len;        
  char input[7];
  int len1 = 3;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *status;
  status  = (char *) malloc(len+1);
  sprintf(status  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);

//---------------------------------------------------------------
//   set status flag
//---------------------------------------------------------------

  if (!strncmp(status,"ON",2)) rc99SelectTracksStatus = 1;

};
