// ********************************************************************
//
//  Routine:      rcSetRTRArelations
//  Author:       T.Oest
//
//  Description:  set missing RTRA relations
//
//  Modification:
//
// ********************************************************************

#include <iostream>
#include <set>
#include <math.h>

#include <arte/arte.hh>
#include <arte/RSEG_cmp.hh>

// ********************************************************************
//  function
// ********************************************************************
void rcSetRTRArelations( ArtePointer<RTRA> rtra){


//-------------------------------------------------------------------
// copy vds/otr hitb from rseg and set link to rtra track 
//-------------------------------------------------------------------

  for( ArteRelationIterator<RSEG> rseg = rtra->rseg.begin();
       rseg != rtra->rseg.end(); ++rseg ) {
  if ((*rseg)->fit !=7){

  if (((*rseg)->cmp & Rsegc::vxd)  != 0 ||
      ((*rseg)->cmp & Rsegc::patt) != 0)  {

   ArtePointer<RSEG> vds  = *rseg;

   ArteRelationIterator<RHIT> rhit = vds->rhit.end();

   while ( rhit != vds->rhit.begin()) {

    ArteRelationIterator<RHIT> rhit2 = vds->rhit.begin();
    ArteRelationIterator<RHIT> rhit3 = vds->rhit.begin();

    while (++rhit2 != rhit) {++rhit3;};
    rhit = rhit3;

    ArtePointer<RHIT> Prhit(rhit);
    ArtePointer<HITB> Phitb(Prhit->hitb);

    RHIT rhitnew;
    rhitnew.x  = Prhit->x;
    rhitnew.y  = Prhit->y;
    rhitnew.tx = Prhit->tx;
    rhitnew.ty = Prhit->ty;
    rhitnew.p  =  rtra->pf;
    rhitnew.q  = Prhit->q;
    ArtePointer<RHIT> Prhitnew = ArteTable<RHIT>::push_back(rhitnew);
    Prhitnew->rtra =  rtra;
    createRelation( Phitb, Prhitnew, &HITB::rhit );
    createRelation(  rtra, Phitb, &RTRA::hitb );
   };

  };};};

//---------------------------------------------------------------
// set link to ECAL hitc
//---------------------------------------------------------------

  for( ArteRelationIterator<RCCL> rccl = rtra->rccl.begin();
       rccl != rtra->rccl.end(); ++rccl ) {

    for( ArteRelationIterator<HITC> hitc = (*rccl)->hitc.begin();
         hitc != (*rccl)->hitc.end(); ++hitc ) {
     ArtePointer<HITC> Phitc(hitc);
     createRelation( rtra, Phitc, &RTRA::hitc );
    };

  };

//---------------------------------------------------------------
// set link to RICH hitb
//---------------------------------------------------------------

  for( ArteRelationIterator<RSEG> rseg = rtra->rseg.begin();
       rseg != rtra->rseg.end(); ++rseg ) {
  if ((*rseg)->fit !=7){

  if (((*rseg)->cmp & Rsegc::rich)  != 0 )  {

   ArtePointer<RSEG> rich = *rseg;

   for( ArteRelationIterator<HITB> hitb = rich->hitb.begin();
        hitb != rich->hitb.end(); ++hitb ) {
    ArtePointer<HITB> Phitb(hitb);

    createRelation( rtra, Phitb, &RTRA::hitb );
   };

  };};}




};


