#ifndef _RICHDB_H_
#define _RICHDB_H_


#include "rich/ricutil.h"
#include "rich/PhotonDetection.h"
#include "rich/PhiLambda.h"

extern "C" {
#include "event.h"
#include "etb.h"
#include "emg.h"
#include "component.h"
#include "grr.h"
#include "libr.h"
#include "log.h"
#include "table.h"
}


class DAQ_INITIALIZATION {
 private:
  Tables tid;
  ScriptFile* file;
  char *PMType[3], *ASDConn[4], *ASD[4], *way;
  int *SuperMod, *PMBRow, *PMBCol, *MotherB, *DaughterB, *DBConn;
  int *PMT, *Pad, *Channel;
  int *Chan_ID;
  short *Chan_Stat;
  int fsize;
 public:
  
  /// Constructor opening the database.  
  DAQ_INITIALIZATION(char *sours=0);
  
  /// returns the fields size of booked tables
  inline int FS(){return fsize;}
  
  /// Takes the data from ASD table.
  int ASDInitialization();
  
  /// Takes the data from M16WireMap table
  int M16WInitialization();
  
  /// Takes the data from M4WireMap table
  int M4WInitialization();
  
  /// Set the status of all channels equal 1.
  int DefaultStatus();
  
  /// Takes the data from ChannelStatus table.
  int ChannelStatus();
  
  /// Takes the status of the channels from data file.
  int StatusfromFile();
  
  /// if 'sours' is the name of file, reading information from file,
  /// if no argument 'sours', reading information from database.
  int sours_selector (char* subject=0);

  /// Printing out the list of bad channels tables. Each table relates 
  /// with run number and consists from list of bad channels for this run
  int BadTablesList();
  
  /// Reterns the information about one  ASD8 board
  int asd_scan(char* ftag,char* fasd, int* fsm, int* fr,\
	       int *fc, int *ffedid, int *fd, int *fcon);
  /// Reterns the string with the mapping of one channel 
  int m16_scan(char* s);
  
  /// Reterns the string with the mapping of one channel 
  int m4_scan(char* s);
  
  /// Reterns the information about status of one chanel
  int channelstatus_scan(int* id, short* stat);
  
  /// Destructor closing the database's tables or data files.
  ~DAQ_INITIALIZATION();
};

extern DAQ_INITIALIZATION *init;

#endif



