
// ********************************************************************
//
//  Routine:      RICHrec
//
//  Description:  rich reconstruction based on tracks
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "rich/RICHDAQ.h"
#include "rise/RingSearchARTE.h"

#include "rire/richreco.hh"

extern "C" void dric2hitb_();


//*****************************************************************
// function
//*****************************************************************

int RICHrec(int level=10) {

//==================================================================
// 1. create hits
//           hidric_(): fills HITB table with RICH hits
//==================================================================

  //  if (level == 1 || level == 3) hidric_();
  //if (level == 1 || level == 3) dric2hitb_();
  
  //create vector of RICH hits
  RichHits *richhits=new RichHits();
  
//=================================================================
//2.loop over reconstructed tracks and find likelihoods for each 
//  mass hypothesis
//==================================================================
  
  for(ArteTable<RTRA>::iterator rtrait=ArteTable<RTRA>::begin();
      rtrait!=ArteTable<RTRA>::end();rtrait++)
    {

      RichTrack rtrack(*rtrait);    //initialise RichTrack

/*
      float like[5];
      float likesum=0;

      rtrack.FindLikelihoods(richhits);

      for(int i=0;i<5;i++){
        like[i]=exp(rtrack.Likelihood(i+1));
        likesum+=like[i];
      }                                 
      
      for(int i=0;i<5;i++){
        like[i]/=likesum;
      }                  
*/       
      (*rtrait)->lre=rtrack.Likelihood(1);
      (*rtrait)->lrmu=rtrack.Likelihood(2);
      (*rtrait)->lrpi=rtrack.Likelihood(3);
      (*rtrait)->lrk=rtrack.Likelihood(4);
      (*rtrait)->lrp=rtrack.Likelihood(5);
    }
  delete richhits;

  return 0;
}




