//--*-C++-*--
#ifndef __RingSearchARTE_H__
#define __RingSearchARTE_H__

#include "rise/ring.h"
#include "rise/RingSearchDB.h"

extern "C"
{
  void rcrings_(float r1=30,float r2=53,float dr=-1,int t=5);
  void rcringsdb_();
}

///////////////////// RingSearchARTE ////////////////////////////////////

class RingSearchARTE : public RingSearchDB {
private:
  Hits      h;
  DualSpace d;
  void reFit();
  void FillRSEG();
  void makeHitMap();
public:
  RingSearchARTE();
  void   getrings(float r1,float r2,float dr,int t);
  void   getrings();
  inline int    numrings()    const { return d.numring();  }
  inline double phi(int i)    const { return d.x0refit(i); }
  inline double lambda(int i) const { return d.y0refit(i); }
  inline double tx(int i)     const { return d.tx(i);      }
  inline double ty(int i)     const { return d.ty(i);      }
  inline double radius(int i) const { return d.radius(i);  }
  inline Ring   &getRing(int i)     { return d.getRing(i); }
  inline int    imtra(int i)  const { return d.mctrack(i); }
};

extern RingSearchARTE *RICH_Search;

#endif
