#ifndef _RICHSEARCHDB_H_
#define _RICHSEARCHDB_H_

class RingSearchDB {

 protected:
  float  MinSearchRadius,MaxSearchRadius,SearchStep;
  int    OccupancyCut, Threshold;

 public:
  
  static int distribute;

  inline RingSearchDB() { 
    // -- MC by default
    OccupancyCut=10000; 
    Threshold=5;
    MinSearchRadius=30; 
    MaxSearchRadius=53; 
    SearchStep=-1; 
  }
  void   getSearchParameters (int run_no,int verb=0);
  void   fillSearchParameters(int run_no, float *parameters,int verb=0);

  inline float &minSearchRadius() { return MinSearchRadius; }
  inline float &maxSearchRadius() { return MaxSearchRadius; }
  inline float &searchStep()      { return SearchStep; }
  inline int   &occupancyCut()    { return OccupancyCut; }
  inline int   &threshold()       { return Threshold; }

};

extern "C"
int UpdateRadiusDatabase(int major, float *parameters,int verb=0);

#endif
