//--*-C++-*--
#include "RICHEventMC.h"
#include "CLHEP/Hist/HBookTuple.h"

#ifdef USE_ROOT

#include "TFile.h"
#include "TTree.h"
#include "TBranch.h"

/** Compares RingSearch reconstruction parameters with MC values. 
Usage: 
- define ROOTFILE in you kumac (directory where to save root file)
- and in usevnt call, AFTER ring reconstruction:
RICH_Efficiency = new RingSearchEfficiency;
RICH_Efficiency->fillNtuple;
  */
class RingSearchEfficiency {

 private:
  typedef struct {
    float mc_tx, mc_ty, mc_rad;
    float rc_tx, rc_ty, rc_rad;
    float mc_x[3];
    float mc_Tx, mc_Ty;
    float mc_p;
    float mc_pho, rc_pho;
    float mc_type, mc_moth;
    float multi;
  } Ring;
  Ring ring;

  TFile *ring_file;
  TTree *ring_tree;

 public:
  RingSearchEfficiency();
  ~RingSearchEfficiency();
  void fillNtuple();
};

extern RingSearchEfficiency *RICH_Efficiency;

#endif
