#ifndef _L3_ARTE_HH_
#define _L3_ARTE_HH_
#include "L3_Defines.hh"

class L3_Event;
class L3_Track;
#include "arte/arte.hh"

class L3_Arte {
public:
  L3_Arte();
  L3_Arte(const L3_Arte&);
  L3_Arte& operator = (const L3_Arte&);
  void flush();
  void fill(const L3_Event&);

  static char* particleName(char *s);
  static void hitb2svd( const ArtePointer<HITB> i,int *sl,int *sec=NULL,int *lay=NULL);
  static int svdHitsPresent(); //check whether this event has any svd HITB
  static int Btag(ArtePointer<MTRA> m,int depth);
private:
  ArtePointer<RSEG> track2rseg(L3_Track&);
  ArtePointer<RTRA> track2rtra(L3_Track&);
  void MakeRPNT(L3_Track&, ArtePointer<RSEG>, ArtePointer<RTRA> );

};

#endif
