#ifndef _L3_MONITOR_HH_
#define _L3_MONITOR_HH_
#include "L3_Defines.hh"

#ifdef L3_GCC
#include <vector.h>
#endif
#ifdef L3_EGCS
#include <vector>
#endif

class L3_Event;
class L3_State;
class L3_Timer;
class L3_Track;
class L3_SpacePoint;
class L3_Vertex;

#ifndef L3_NO_RHP
#include "L3_RHP.hh"

class L3_Monitor {
public:
  L3_Monitor();
  L3_Monitor(const L3_Monitor&);
  L3_Monitor& operator = (const L3_Monitor&);
  void init();
  void put(const L3_Event&);
  void put(const L3_State&);
  void put(const L3_Timer&);
  void stop();
private:
  void put(vector<L3_Track> TrackList);
  void put(vector<L3_SpacePoint> PointList);
  void put(vector<L3_Vertex> PrimVtxList);
};

#endif
#endif
