#ifndef _L3_ORIGIN_HH_
#define _L3_ORIGIN_HH_
#include "L3_Defines.hh"
#include "L3_Track.hh"
#include "L3_Vertex.hh"
#include "L3_Timer.hh"
#include "L3_Vtx.hh"

class L3_Origin {
public:
  inline L3_Origin();
  inline L3_Origin(const L3_Origin&);
  inline L3_Origin& operator = (const L3_Origin&);
  void reconstruct(vector<L3_Track>&, L3_Timer&);   //reconstruction routine
  inline vector<L3_Vertex> primVertices() const;    //found primary vertices
  inline vector<L3_Vertex> primVerticesNew() const;    //found primary vertices
  inline vector<L3_Vertex> secVertices() const;     //found secondary vertices
  inline vector<L3_Vertex> Vertices() const;        //all found vertices
  inline int nVertices() const;              //number of found vertices
  inline int nPrimVertices() const;              //number of found primary vertices
  inline int nSecVertices() const;              //number of found secondary vertices
  inline void release(); //clear all data
  static void init();
private:
  int cnt;
  vector<L3_Vertex> primVertexList; //list with primary vertices
  vector<L3_Vertex> primVertexListNew; //list with primary vertices
  vector<L3_Vertex> secVertexList; //list with secondary vertices

  inline float TrackDist(L3_Track &a,L3_Track &b); 
  vector<L3_Track>::iterator BestMatch(L3_Track &toMatch,vector<L3_Track> &list2search,float *bestdist=NULL);

  void VTreco(vector<L3_Track> &,vector<L3_Track>&);
  void cutBefore(vector<L3_Track> &list);
  void addTracks(L3_Vtx &vtx,vector<L3_Track> &tr);
  void MYreco(vector<L3_Track> &);
  void SLTreco(vector<L3_Track> &,vector<L3_Track>&);
};

#include "L3_Origin.icc"

#endif
