#ifndef _L3_STATE_HH_
#define _L3_STATE_HH_
#include "L3_Defines.hh"

#include "L3_Event.hh"
#include "L3_Timer.hh"

class L3_State {
public:
  L3_State();
  L3_State(const L3_State&);
  L3_State& operator = (const L3_State&);

  void update(const L3_Event&);
  void read(const L3_Timer&);

  int nEvents() const;
  int nEventsAccepted() const;
  int nSpacepoints() const;
  int nTracks() const;
  float dtPointReco() const;
  float dtTrackReco() const;
  float dtVertexReco() const;
  float dtTrigger() const;

  void print() const;
  void printEVHD() const;
  void printSummary() const;
private:
  int NumberOfEventsProcessed;
  int NumberOfEventsAccepted;
  int TotalNumberOfReconstructedSpacepoints;
  int TotalNumberOfReconstructedTracks;
  float dt_PointReco;
  float dt_TrackReco;
  float dt_VertexReco;
  float dt_Trigger;
};

#endif
