#ifndef _L3_TIMER_HH_
#define _L3_TIMER_HH_
#include "L3_Defines.hh"
#include "L3_Chrono.hh"

class L3_Timer {
public:
  L3_Timer();
  L3_Timer(const L3_Timer&);
  L3_Timer& operator = (const L3_Timer&);
  void reset();
  void start_PointReco();
  void stop_PointReco();
  void start_TrackReco();
  void stop_TrackReco();
  void start_Trigger();
  void stop_Trigger();
  void start_Vertex();
  void stop_Vertex();
  void print_PointTime() const;
  void print_TrackTime() const;
  void print_TriggerTime() const;
  void print_VertexTime() const;
  float lastPointTime() const;
  float lastTrackTime() const;
  float lastTriggerTime() const;
  float lastVertexTime() const;
  void print() const;
private:
  L3_Chrono Point_Clock;
  L3_Chrono Track_Clock;
  L3_Chrono Trigger_Clock;
  L3_Chrono Vertex_Clock;
};
#endif
