#ifndef _L3_VTPROTO_HH_
#define _L3_VTPROTO_HH_

#include "L3_VTtypes.hh"
#include <CLHEP/Utilities/fortran.h>

extern "C"
{
  void FORTRAN_ROUTINE( vtzero )();
  double FORTRAN_ROUTINE( vtdtt )( const int& t1, const int& t2 );
  void FORTRAN_ROUTINE( vtinit )( Point& p, PCovMatrix& c, int& iv, int& flag );

  //void FORTRAN_ROUTINE( vtadd )( const int& iv, const ArtePointer<RTRA>& it, int& flag );
  void FORTRAN_ROUTINE( vtadd )( const int& iv, const int& track, int& flag );
  void FORTRAN_ROUTINE( vtkill )( const int& iv, const int& track, int& flag );
  void FORTRAN_ROUTINE( vtdel )( const int& iv, int& flag );

  void FORTRAN_ROUTINE( vtfit )( const int& iv, const int& momflg, int& flag );

  void FORTRAN_ROUTINE( vtwini )( const int& iw );
  void FORTRAN_ROUTINE( vtprim )( const int& itB, int& flag );
  void FORTRAN_ROUTINE( vtreco )( int& flag );
  void FORTRAN_ROUTINE( vtwir )( int& wirenr );

  //double FORTRAN_ROUTINE( vtdtp )( const int& iv, const ArtePointer<RTRA>& it);
  double FORTRAN_ROUTINE( vtdtp )( const int& iv, const int& it);
  // spatial distance of track and vertex:

  //double FORTRAN_ROUTINE( vtdvt )( const int& iv, const ArtePointer<RTRA>& it);
  double FORTRAN_ROUTINE( vtdvt )( const int& iv, const int& it);
  // chi**2 distance of vertex and track:       

  void FORTRAN_ROUTINE( vtdis )( const int& iv, int& flag);   
  // get smoothed residuals for tracks on iv
  // get new state vectors and covariance matrices
  // with a point removed:        
  
  void FORTRAN_ROUTINE( lftrbf )();
}
#endif
