#ifndef _L3_VERTEX_HH_
#define _L3_VERTEX_HH_
#include "L3_Defines.hh"

#ifdef L3_GCC
#include <iostream.h>
#include <math.h>
#include <vector.h>
#endif
#ifdef L3_EGCS
#include <iostream>
#include <cmath>
#include <vector>
#endif

#include <CLHEP/Vector/ThreeVector.h>

#include "L3_Track.hh"
#include "L3_Vtx.hh"

class L3_Vertex {
public:
  inline L3_Vertex();
  L3_Vertex(const L3_Vtx&);
  L3_Vertex(const L3_Vertex&);
  L3_Vertex(const L3_Track&, const L3_Track&);
  L3_Vertex& operator = (const L3_Vertex&);
  inline int operator == (const L3_Vertex&) const;
  inline int operator != (const L3_Vertex&) const;
  inline ostream& operator << (const L3_Vertex&) const;
  inline void add(const vector<L3_Track>&);
  inline Hep3Vector vertex() const;
  inline float x() const;
  inline float y() const;
  inline float z() const;
  inline float dx() const;
  inline float dy() const;
  inline float dz() const;
  inline float chisqr() const;  
  inline vector<L3_Track> OutgoingTracks() const;
  inline int nOutgoingTracks() const;
  inline vector<int> OutgoingTracksNr() const;
private:
  vector<L3_Track> AssociatedTracks;
  Hep3Vector Vertex;
  double covmatrix[3][3];
  float chiSquare;
  int Status;
  inline void add(const L3_Track&);
  void fit2(const L3_Track&, const L3_Track&);
};

#include "L3_Vertex.icc"

#endif
