*
*-- Author :    Vik   11/11/98
*

      SUBROUTINE TRD_CRTR(N_MR,I,N_BLOK,N_ROW,K,A,B,SIGMA_2)

**********************************************************************
*
* Description: update track information
*
* Called from: TRD_TRA
*
*          in: N_MR    - Matrix number
*              I       - Seed number for matrix N_MR
*              N_BLOK  - TRD blok
*              N_ROW   - TRD layer
*              K       - track candidate number
*         out: A, B    - track parameters
*              SIGMA_2 - sigma**2 
*
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"


      DOUBLE PRECISION SUM_X, SUM_Z, SUM_X_Z, SUM_Z_2, A, B       
      REAL X_BL_LEFT, DEL_Z, D_STRAW, X_ROW, Z_ROW, 
     +     Z_BL_ST, Y_BL_LT, Y_BL_RT,
     +     SIGMA_2, X_BL_RT
      INTEGER N_MAX, ROAD, FLAG, N_STR_HIT,N_MR,I,N_BLOK,N_ROW,K,
     +        ROW, NN_BLOK, TRD_VIEW, TRD_HITB, N_STRAW, TRACK

      COMMON /TRD_LEFT/ X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT
      COMMON /TRD_ROAD/ ROAD, FLAG, N_STR_HIT, TRACK
      COMMON /TRD_ALL/ TRD_VIEW, TRD_HITB

      PARAMETER (N_MAX = 1000) 
      DIMENSION X_BL_LEFT(12,16), Z_BL_ST(12,16)
      DIMENSION Y_BL_LT(12,16), Y_BL_RT(12,16), X_BL_RT(12,16)
      DIMENSION ROAD(N_MAX,15,16,3), N_STR_HIT(3)
      DIMENSION FLAG(N_MAX,15,16), TRACK(N_MAX,15,100)
      DIMENSION X_ROW(16), Z_ROW(16)
      DIMENSION TRD_VIEW(12,16,78), TRD_HITB(12,16,78)
C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
C
C TRD Event Analysis.
C
*      PRINT *,'START CRTR analysis for TRD'
C
      CALL VZERO(X_ROW,16)
      CALL VZERO(Z_ROW,16)
C
      DEL_Z   = 2.3125
      D_STRAW = 0.61
      SUM_X   = 0.
      SUM_Z   = 0.
      SUM_X_Z = 0.
      SUM_Z_2 = 0.
      SIGMA_2 = 0.
C
      DO ROW = 1, N_ROW
        IF(ROAD(N_MR,I,ROW,K).NE.0) THEN
         X_ROW(ROW) = X_BL_LEFT(N_BLOK,ROW) + ROAD(N_MR,I,ROW,K) *
     +                D_STRAW - D_STRAW/2
         Z_ROW(ROW) = Z_BL_ST(N_BLOK,ROW)
       END IF
      END DO
C
      DO ROW = 1, N_ROW
       IF(Z_ROW(ROW).NE.0) THEN
         SUM_X   = SUM_X + X_ROW(ROW)
         SUM_Z   = SUM_Z + Z_ROW(ROW)
         SUM_X_Z = SUM_X_Z + X_ROW(ROW)*Z_ROW(ROW)
         SUM_Z_2 = SUM_Z_2 + Z_ROW(ROW)*Z_ROW(ROW)
       END IF
      END DO
C
      A = (N_ROW*SUM_X_Z - SUM_Z*SUM_X)/(N_ROW*SUM_Z_2 - SUM_Z*SUM_Z)
      B = (SUM_X*SUM_Z_2 - SUM_Z*SUM_X_Z)/(N_ROW*SUM_Z_2 - SUM_Z*SUM_Z)
C
      DO ROW = 1, N_ROW
       IF(Z_ROW(ROW).NE.0) THEN
          SIGMA_2 = SIGMA_2 + (X_ROW(ROW) - A*Z_ROW(ROW) - B)**2
       END IF
      END DO       
C
*      PRINT *,'STOP CRTR analysis for TRD'
C
 900  END

*********************************************************************
* End of TRD_CRTR
************************************************************************
