#include <stdio.h>
#include <stdlib.h>
#include "wax/OTrDecode.h"
#include <string.h>
#ifdef USE_ARTE
  #include <arte/Arte.h>
  #include <arte/ArteUtil.h>
  #include <auto/GEDE.h>
  #include <auto/GESL.h>
#endif

typedef struct{
  unsigned short mod_first_wire;
  unsigned short mod_last_wire;
  char           side;
  unsigned char  crate;  
  unsigned char  slot;
  unsigned char  prev_sector1;
  unsigned char  prev_sector2;
  unsigned char  prev_ASD1;
  unsigned char  prev_ASD2;
  unsigned char  next_sector1;
  unsigned char  next_sector2;
  unsigned char  next_ASD1;
  unsigned char  next_ASD2;
  char           mod_type[4];         
}ASD8_tmp;

#ifdef USE_ARTE
  extern int ARTE_get_recid_DOTR(int *);
  extern int ARTE_get_feds_DOTR(int,ETB_fed *,int *);
#endif

OTR_Decode *OTr_Decode_init(int mode,const char *Tables_filename,
			    const char *TDC_table_filename){
FILE *TablesList,*Table,*TDCTable;
static OTR_Decode *OTR;
static int init=0;
ASD8_tmp *tmpasd[MAXASD];
unsigned short i,j,k,NLine=0;
char TableName[400],string[400];
unsigned char NLay;
unsigned short pos;
//------------------------
unsigned char SL,crate,slot;
int FED,module;
char side;
unsigned short fedline=0,Line;
int nasds ;
int VME_num,Sharc_Board,Sharc_Connector;
char link[10];
//------------------------
unsigned int igede,ngede,mono,wire;
  if(!init){
    init=1; 
  }else{  
    return OTR;
  }
  TablesList=fopen(Tables_filename,"r");
  if(TablesList==NULL){
    printf("\nError: Can't open file %s\n",Tables_filename);
    return NULL;
  }
  TDCTable=fopen(TDC_table_filename,"r"); 
  if(TDC_table_filename==NULL){
    printf("\nError: Can't open file %s\n",TDC_table_filename);
    return NULL;
  }
  OTR=malloc(sizeof(OTR_Decode));
  if(OTR==NULL){
    printf("\nMemory allocation error...\n");
    return NULL;
  }
  for(i=0;i<MAXTDC;i++) OTR->TDCs[i]=NULL;
  for(i=0;i<MAXFED;i++) OTR->FEDs[i]=MAXFED;
  for(i=0;i<MAXASD;i++) OTR->ASD8s[i]=NULL;
  /*---------------- cabling strings loop -----------------*/  
  do{
     if(fscanf(TablesList,"%s",TableName)==EOF) break;
     Table=fopen(TableName,"r");
     if(Table==NULL){
       printf("\nError: Can't open file %s\n",TableName);
       return NULL;
     }
     fgets(string,399,Table);
     do{
       if(fgets(string,399,Table)==NULL) break;
       pos=0;
       for(i=0;i<=399;i++){
         if(string[i]==0) break;
         if(string[i]=='m' ||string[i]=='p' ||string[i]=='t' ||string[i]=='s'){
	   pos++;
           if(pos==1){
             OTR->ASD8s[NLine]=malloc(sizeof(OTrASD8));
	     if(OTR->ASD8s[NLine]==NULL){
	       printf("\nMemory allocation error...\n");
	       return NULL;
	     }
	     for(k=0;k<16;k++){
	       OTR->ASD8s[NLine]->wire[k].GEDE=0;
	       OTR->ASD8s[NLine]->wire[k].cell=0;
	     }
	     tmpasd[NLine]=malloc(sizeof(ASD8_tmp));
	     if(OTR->ASD8s[NLine]==NULL){
	       printf("\nMemory allocation error...\n");
	       return NULL;
	     }
	     NLine++;
             if(string[i]=='m') 
	       OTR->ASD8s[NLine-1]->SuperLayer=atoi(string+i+1);
             if(string[i]=='p') 
	       OTR->ASD8s[NLine-1]->SuperLayer=8+atoi(string+i+1);
             if(string[i]=='t') 
	       OTR->ASD8s[NLine-1]->SuperLayer=12+atoi(string+i+1);
             OTR->ASD8s[NLine-1]->Layer=atoi(string+i+3);
             OTR->ASD8s[NLine-1]->Sector=atoi(string+i+5);
	     tmpasd[NLine-1]->side=string[i-1];
	     if(tmpasd[NLine-1]->side=='+')
	       OTR->ASD8s[NLine-1]->SuperLayer+=16;
	   }
           if(pos==3){
             OTR->ASD8s[NLine-1]->Module=atoi(string+i+5);
             for(j=0;j<=10;j++) OTR->ASD8s[NLine-1]->hwc[j]=string[i+j-1];
             OTR->ASD8s[NLine-1]->hwc[11]=0;
	     tmpasd[NLine-1]->mod_first_wire=atoi(string+i+11);
           }
           if(pos==4){
	     tmpasd[NLine-1]->mod_last_wire=atoi(string+i+11);
           }
           if(pos==7){
             OTR->ASD8s[NLine-1]->ftb_ASD=atoi(string+i+8);
	     for(k=0;k<16;k++){ 
	       OTR->ASD8s[NLine-1]->wire[k].ASD=NLine-1;
	       OTR->ASD8s[NLine-1]->wire[k].wire=k; 
	     }
           }
           if(pos==13){
	     tmpasd[NLine-1]->crate=atoi(string+i+3);
	     tmpasd[NLine-1]->slot=atoi(string+i+5);
             OTR->ASD8s[NLine-1]->TDC_Connector=atoi(string+i+8);  
	   }
           if(pos==14){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->prev_sector1=0;
	       tmpasd[NLine-1]->prev_ASD1=0;
             }else{
	       tmpasd[NLine-1]->prev_sector1=atoi(string+i+5);
	       tmpasd[NLine-1]->prev_ASD1=atoi(string+i+8);
             }
           }
           if(pos==15){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->prev_sector2=0;
	       tmpasd[NLine-1]->prev_ASD2=0;
             }else{
	       tmpasd[NLine-1]->prev_sector2=atoi(string+i+5);
	       tmpasd[NLine-1]->prev_ASD2=atoi(string+i+8);
             }
           }
           if(pos==16){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->next_sector1=0;
	       tmpasd[NLine-1]->next_ASD1=0;
             }else{
	       tmpasd[NLine-1]->next_sector1=atoi(string+i+5);
	       tmpasd[NLine-1]->next_ASD1=atoi(string+i+8);
             }
           }
           if(pos==17){
             if(atoi(string+i+3)==0){
	       tmpasd[NLine-1]->next_sector2=0;
	       tmpasd[NLine-1]->next_ASD2=0;
             }else{
	       tmpasd[NLine-1]->next_sector2=atoi(string+i+5);
	       tmpasd[NLine-1]->next_ASD2=atoi(string+i+8);
             }
             for(j=0;j<20;j++) if(string[i+11+j]!=' ') break;
             for(k=0;k<=2;k++) tmpasd[NLine-1]->mod_type[k]=string[i+11+j+k];
	   }
	 }
       }
     }while(1);
     fclose(Table);
  }while(1);  
  fclose(TablesList);

  /*------------- end of cabling strings loop --------------*/  
  /*------------------ start TDC-FED loop ------------------*/
  fgets(string,100,TDCTable);
  fgets(string,100,TDCTable);
  while(fgets(string,100,TDCTable)!=NULL)
    if(strlen(string) > 1 ) { /* check that line is not empty */
      if(string[1]=='m') SL=atoi(string+2);
      if(string[1]=='p') SL=8+atoi(string+2);
      if(string[1]=='t') SL=12+atoi(string+2);
      if(string[1]=='s') SL=14+atoi(string+2);
      side=string[0];
      if(side=='+') SL+=16;
      crate=atoi(string+4);
      slot=atoi(string+6);
      VME_num=0; Sharc_Board=0;
      sscanf(string+10,"%0x %i %0x %s",&FED,&VME_num,&Sharc_Board,link);
      Sharc_Connector=(atoi(link)-1)*6+atoi(link+2);
      nasds=0;
      for(i=0;i<NLine;i++) 
	if(tmpasd[i]->crate==crate && tmpasd[i]->slot==slot &&
	   tmpasd[i]->side==side && OTR->ASD8s[i]->SuperLayer==SL){  
	  OTR->ASD8s[i]->TDC_FED=FED;
	  nasds++;
	  if(OTR->FEDs[FED]!=MAXFED){
	    OTR->TDCs[OTR->FEDs[FED]]->ASD[OTR->ASD8s[i]->TDC_Connector-1]=i;
	  }else{
	    OTR->FEDs[FED]=fedline;
	    OTR->TDCs[fedline]=malloc(sizeof(OTrTDC));
	    if(OTR->TDCs[fedline]==NULL){
	      printf("\nMemory allocation error...\n");
	      return NULL;
	    }
	    for(j=0;j<8;j++) OTR->TDCs[fedline]->ASD[j]=MAXFED; 
	    OTR->TDCs[OTR->FEDs[FED]]->ASD[OTR->ASD8s[i]->TDC_Connector-1]=i;
	    OTR->TDCs[fedline]->crate = crate ;
	    OTR->TDCs[fedline]->slot  = slot ;
	    OTR->TDCs[fedline]->FED=FED;
	    if(VME_num!=0 && Sharc_Board!=0 && Sharc_Connector!=0){
	      OTR->TDCs[fedline]->VME_num=VME_num;
	      OTR->TDCs[fedline]->Sharc_Board=Sharc_Board;
	      OTR->TDCs[fedline]->Sharc_Connector=Sharc_Connector;
	    }else{
	      OTR->TDCs[fedline]->VME_num=0;
	      OTR->TDCs[fedline]->Sharc_Board=0;
	      OTR->TDCs[fedline]->Sharc_Connector=0;
	    }
	    fedline++;
	  }
	}
#ifdef __OTR_DEBUG__
      if(nasds==0) {
	printf("Error in OTrDecode: No asds found for FED %s",string) ;
      }
#endif
    }
  fclose(TDCTable);

  /*----------------- end of TDC-FED loop ------------------*/
  /*------------- start SL,Lay,Sect,ASD loop ---------------*/
  for(i=0;i<32;i++){
    OTR->Slayers[i].NLayer=0; 
    for(k=0;k<13;k++) for(j=0;j<7;j++){
      OTR->Slayers[i].Nasd[j][k]=0; 
      OTR->Slayers[i].FirstASD[j][k]=255;
    }
  }
  for(j=0;j<NLine;j++){
    OTR->Slayers[OTR->ASD8s[j]->SuperLayer].Nasd[OTR->ASD8s[j]->Layer]
      [OTR->ASD8s[j]->Sector]++;
    if(OTR->Slayers[OTR->ASD8s[j]->SuperLayer].FirstASD[OTR->ASD8s[j]->Layer]
       [OTR->ASD8s[j]->Sector] > OTR->ASD8s[j]->ftb_ASD)
      OTR->Slayers[OTR->ASD8s[j]->SuperLayer].FirstASD[OTR->ASD8s[j]->Layer]
        [OTR->ASD8s[j]->Sector]=OTR->ASD8s[j]->ftb_ASD;
  }
  for(i=0;i<32;i++){
    NLay=0;
    pos=1;
    for(k=0;k<13;k++) for(j=0;j<7;j++){
      if(OTR->Slayers[i].FirstASD[j][k]<255){
        OTR->Slayers[i].pos[j][k]=pos;
        pos+=OTR->Slayers[i].Nasd[j][k];
	if(NLay<j) NLay=j;
      }    
    }
    OTR->Slayers[i].Line=malloc(pos*sizeof(unsigned short));
    OTR->Slayers[i].NLayer=NLay;
  }
  for(i=0;i<NLine;i++){
    OTR->Slayers[OTR->ASD8s[i]->SuperLayer].Line[
      OTR->Slayers[OTR->ASD8s[i]->SuperLayer].
      pos[OTR->ASD8s[i]->Layer][OTR->ASD8s[i]->Sector]-
      OTR->Slayers[OTR->ASD8s[i]->SuperLayer].
      FirstASD[OTR->ASD8s[i]->Layer][OTR->ASD8s[i]->Sector]+
      OTR->ASD8s[i]->ftb_ASD]=i;
  }
  /*-------------- end SL,Lay,Sect,ASD loop ----------------*/
  /*---------------------- begin GEDE ----------------------*/
#ifdef USE_ARTE
  ngede = NGEDE();
  for(igede=1; igede <= ngede; igede++){
    if(GEDE(igede).cmp==2 && GEDE(igede).hwc[0]!='n'){
      for(j=0;j<11;j++) string[j]=GEDE(igede).hwc[j];
      string[11]=0;
      for(i=0;i<NLine;i++){
	if(!strncmp(string,OTR->ASD8s[i]->hwc,12)){
	  for(k=0;k<16;k++){
	    if(GEDE(igede).nsl==2 && GEDE(igede).hwc[0]=='-'){ 
	      module=OTr_Convert_ASD_to_GEDE(0,tmpasd[i]->mod_first_wire,
				       k+1,0,GEDE(igede).nwi,&mono,&wire);
	      if(wire<GEDE(igede).nwi[mono]){
		OTR->ASD8s[i]->wire[k].GEDE=igede;
		OTR->ASD8s[i]->wire[k].cell=wire+32*mono ;
	      }
	    }
	    if(GEDE(igede).nsl==2 && GEDE(igede).hwc[0]=='+'){ 
	      module=OTr_Convert_ASD_to_GEDE(0,tmpasd[i]->mod_first_wire,
				       k+1,1,GEDE(igede).nwi,&mono,&wire);
	      if(wire<GEDE(igede).nwi[mono]){
		OTR->ASD8s[i]->wire[k].GEDE=igede;
		OTR->ASD8s[i]->wire[k].cell=wire+32*mono ;
	      }
	    }
	    if(GEDE(igede).nsl==4 && GEDE(igede).hwc[0]=='-'){
	      module=OTr_Convert_ASD_to_GEDE(1,tmpasd[i]->mod_first_wire,
				       k+1,0,GEDE(igede).nwi,&mono,&wire);
	      if(wire<GEDE(igede).nwi[mono] && module==0){
		OTR->ASD8s[i]->wire[k].GEDE=igede;
		OTR->ASD8s[i]->wire[k].cell=wire+32*mono;
	      }

	      if((tmpasd[i]->mod_first_wire+k)==1){
		if(OTr_Decode_ASD_to_ASDindex(OTR,OTR->ASD8s[i]->SuperLayer,
					      OTR->ASD8s[i]->Layer,
					      tmpasd[i]->prev_sector1,
					      tmpasd[i]->prev_ASD1,&Line)){
		  OTR->ASD8s[Line]->wire[12].GEDE=igede;
		  OTR->ASD8s[Line]->wire[12].cell=0;
		  OTR->ASD8s[Line]->wire[14].GEDE=igede;
		  OTR->ASD8s[Line]->wire[14].cell=32;
		}
	      }
	    }
	    if(GEDE(igede).nsl==4 && GEDE(igede).hwc[0]=='+'){
	      module=OTr_Convert_ASD_to_GEDE(1,tmpasd[i]->mod_first_wire,
				       k+1,1,GEDE(igede).nwi,&mono,&wire);
	      if(wire<GEDE(igede).nwi[mono] && module==0){
		OTR->ASD8s[i]->wire[k].GEDE=igede;
		OTR->ASD8s[i]->wire[k].cell=wire+32*mono;
	      }
	      if((wire+1)==GEDE(igede).nwi[2] && mono==2){
		if(OTr_Decode_ASD_to_ASDindex(OTR,OTR->ASD8s[i]->SuperLayer,
					      OTR->ASD8s[i]->Layer,
					      tmpasd[i]->next_sector1,
					      tmpasd[i]->next_ASD1,&Line)){
		  OTR->ASD8s[Line]->wire[1].GEDE=igede;
		  OTR->ASD8s[Line]->wire[1].cell=32+GEDE(igede).nwi[1]-1;
		  OTR->ASD8s[Line]->wire[3].GEDE=igede;
		  OTR->ASD8s[Line]->wire[3].cell=GEDE(igede).nwi[0]-1;
		}
	      }	      
	    }
	  }
	}
      }
    }
  }
  /*----------------------- end GEDE -----------------------*/
#endif

  for(i=0;i<NLine;i++) free(tmpasd[i]); 

  /** temporary, added by wouter **/
  OTr_create_gedes(OTR) ; 
  return OTR;
}

    
int OTr_Decode_TDC_to_ASD(OTR_Decode *OTR,unsigned short FED,
			  unsigned char channel,char *SL,char *Layer,
			  char *Sector,char *ASD){
unsigned short line;
   if(OTR->FEDs[FED]==MAXFED || channel>127) return 0;
   line=OTR->TDCs[OTR->FEDs[FED]]->ASD[channel/16];
   if(line==MAXFED) return 0;    
   if(OTR->ASD8s[line]!=NULL){
     *SL=OTR->ASD8s[line]->SuperLayer;
     *Layer=OTR->ASD8s[line]->Layer;
     *Sector=OTR->ASD8s[line]->Sector;
     *ASD=OTR->ASD8s[line]->ftb_ASD;
   }else return 0;
   return 1;
} 

int OTr_Decode_TDC_to_Sharc(OTR_Decode *OTR,unsigned short FED,
			    unsigned char Channel,unsigned char *VME_num,
			    unsigned char *Board_ID,unsigned short *offset){
unsigned char link;
   if(OTR->FEDs[FED]==MAXFED || Channel>127) return 0;
   *VME_num=OTR->TDCs[OTR->FEDs[FED]]->VME_num;
   *Board_ID=OTR->TDCs[OTR->FEDs[FED]]->Sharc_Board;
   link=OTR->TDCs[OTR->FEDs[FED]]->Sharc_Connector;
   if(*VME_num==0 || *Board_ID==0 || link==0) return 0;
   *offset=(link-1)*128+Channel;
   return 1;
}

int OTr_decode_ASD_to_TDC(OTR_Decode *OTR,unsigned char SL,unsigned char Layer,
			  unsigned char Sector,unsigned char ASD,
			  unsigned short *FED,unsigned char *Conn){
unsigned short line;
  if(OTr_Decode_ASD_to_ASDindex(OTR,SL,Layer,Sector,ASD,&line)){
    *FED=OTR->ASD8s[line]->TDC_FED;
    *Conn=OTR->ASD8s[line]->TDC_Connector;
    return 1;
  }else return 0;
}

int OTr_Decode_ASD_to_ASDindex(OTR_Decode *OTR,unsigned char SL,
			       unsigned char Layer,unsigned char Sector,
			       unsigned char ASD,unsigned short *Line){
  if(Sector<1 || Sector>12 || SL<1 || SL>31 || Layer<1 
     || Layer>OTR->Slayers[SL].NLayer) return 0;
  if(ASD>(OTR->Slayers[SL].Nasd[Layer][Sector]+
	  OTR->Slayers[SL].FirstASD[Layer][Sector]-1) ||
     ASD<OTR->Slayers[SL].FirstASD[Layer][Sector]) return 0; 
  *Line=OTR->Slayers[SL].Line[OTR->Slayers[SL].pos[Layer][Sector]-
                            OTR->Slayers[SL].FirstASD[Layer][Sector]+ASD];
  if(OTR->ASD8s[*Line]==NULL) return 0;
  return 1;
}

int OTr_Convert_ASD_to_GEDE(int dbl, int w1, int ch, int plus, int *wires, 
             int *mono, int *wire){
int w,total_wires; 
    w=w1+ch-1;
    total_wires=wires[0]+wires[1]+wires[2]+wires[3];
    if(!dbl){
      // ------ Single layer ------
      *mono=(plus ? w%2 : !(w%2));
      *wire =(w-1)/2;
      return 0;
    }
    // ------ Double layer ------
    if(plus){
      // ------ +X ------
      if(w==2 || w==4){
	// those ASD channels are connected to 
        // previous chamber
        return -1;
      }
      if(w%2==0){
	// mono#0 or mono#1
        *mono=((w%4==0) ? 0 : 1);
      }else{
        // mono#2 or mono#3
        *mono=((((w-1)%4==0 && w>3) || w==1) ? 3 : 2);
      }
      switch (*mono){
        case 0 : *wire=w/4-2; break;  
        case 1 : *wire=(w-2)/4-1; break;  
        case 2 : *wire=(w-3)/4; break;  
        case 3 : *wire=(w-1)/4; break;  
      }
      return 0;
    }
    // ------ -X ------
    if(w%2==0){
      // mono#0 or mono#1
      *mono=((w%4==0) ? 3 : 2);
    }else{
      // mono#0 or mono#1
      *mono =((((w-1)%4==0 && w>3) || w==1) ? 0 : 1);
    }
    switch (*mono){
      case 3 : *wire =w/4-1; break;  
      case 2 : *wire =(w-2)/4; break;  
      case 1 : *wire =(w-3)/4+1; break;  
      case 0 : *wire =(w-1)/4+1; break;  
    }
    if(w==total_wires-3){
      *wire=0;
      *mono=1;
      return 1;
    }
    if(w==total_wires-1){
      *wire=0;
      *mono=0;
      return 1;
    }
    return 0;
}

int OTr_get_event(OTR_Decode *OTR,int *Nhits,OTrWire **wires[]){
  int rc;
  int recid=0;
  int MaxTDC;
  ETB_fed all_feds[MAXTDC];
  
#ifdef USE_ARTE
  *Nhits=0;
  rc=ARTE_get_recid_DOTR(&recid);
  if(rc==ETB_ok) {
    MaxTDC=MAXTDC; 
    rc=ARTE_get_feds_DOTR(MaxTDC,all_feds,&MaxTDC);
    if(rc==ETB_ok)
      OTr_fill_event(OTR,all_feds,Nhits,wires,MaxTDC);
    else
      printf("OTr_get_event: ARTE_get_feds_DOTR(..) returns %d .\n ", rc) ;
  } else {
    printf("OTr_get_event: ARTE_get_recid(..) returns %d .\n ", rc) ;
  }
#endif
  
  return 1;
}

int OTr_set_tzero(OTR_Decode *OTR,unsigned short GEDE,unsigned char cell,
		  unsigned char tzero){
  return 0;
}

void OTr_create_gedes(OTR_Decode *decodeTable)
{
  int i,mingedeid,maxgedeid ;
  OTrASD8** asdIt ;
  OTrWire* chanIt ;
  OTrGede* gedeIt ;
  OTrGedeWire* wireIt ;
  
  /* determine number of gedes */
  mingedeid=1000000;
  maxgedeid=0;
  for(asdIt=decodeTable->ASD8s ; *asdIt != 0; asdIt++)
    for(chanIt=(*asdIt)->wire ; chanIt!=(*asdIt)->wire+16 ; chanIt++) {
      int gedeindex = chanIt->GEDE ;
      if(gedeindex>0) {
	if(gedeindex<mingedeid) mingedeid=gedeindex ;
	if(gedeindex>maxgedeid) maxgedeid=gedeindex ;
      }
    }
  /* printf("mingedeid/maxgedeid : %d / %d \n",mingedeid,maxgedeid) ; */
  
  /* allocate gedes */
  decodeTable->fMinGedeIndex = mingedeid ;
  decodeTable->fNGedes = maxgedeid-mingedeid+1 ;
  decodeTable->fGedes = malloc(decodeTable->fNGedes*sizeof(OTrGede)) ;

  /* determine number of wires in every gede */
  for(gedeIt = decodeTable->fGedes ; 
      gedeIt != decodeTable->fGedes + decodeTable->fNGedes ; 
      gedeIt++) gedeIt->fNWires=0;
  for(asdIt=decodeTable->ASD8s ; *asdIt != 0; asdIt++)
    for(chanIt=(*asdIt)->wire ; chanIt!=(*asdIt)->wire+16 ; chanIt++) 
      if(chanIt->GEDE>0) {
	gedeIt = decodeTable->fGedes + chanIt->GEDE - decodeTable->fMinGedeIndex ;
	if(gedeIt->fNWires < 1+chanIt->cell) 
	  gedeIt->fNWires = 1+chanIt->cell ;
      }
  
  /* allocate wires and reset */
  for(gedeIt = decodeTable->fGedes ; 
      gedeIt != decodeTable->fGedes + decodeTable->fNGedes ; gedeIt++) {
    gedeIt->fWires = malloc(gedeIt->fNWires*sizeof(OTrGedeWire)) ;
    for(wireIt = gedeIt->fWires; 
	wireIt != gedeIt->fWires + gedeIt->fNWires; wireIt++) {
      wireIt->fAsdIndex=MAXASD;
      wireIt->fChannelIndex=16;
    }
  }
  
  /* set pointers in channels */
  for(asdIt=decodeTable->ASD8s ; *asdIt != 0; asdIt++)
    for(chanIt=(*asdIt)->wire ; chanIt!=(*asdIt)->wire+16 ; chanIt++)
      if(chanIt->GEDE>0) {
	wireIt = decodeTable->fGedes[chanIt->GEDE-decodeTable->fMinGedeIndex].
	  fWires + chanIt->cell ;
	wireIt->fAsdIndex     = asdIt  - decodeTable->ASD8s ;
	wireIt->fChannelIndex = chanIt - (*asdIt)->wire ;
      }

  /* create map which has gedes in right order. sorting is performed in
  OTrEventBuilder, because unfortunately I do not know a c sorting
  library */
  decodeTable->fGedeMap = malloc(decodeTable->fNGedes*sizeof(unsigned short)) ;
  i=0;
  for(gedeIt = decodeTable->fGedes ; 
      gedeIt != decodeTable->fGedes + decodeTable->fNGedes ; gedeIt++)
    if(gedeIt->fNWires>0) {
      decodeTable->fGedeMap[i] = gedeIt - decodeTable->fGedes ;
      i++ ;
    }
  decodeTable->fGedeMapEnd = decodeTable->fGedeMap + i ;
}

int OTr_fill_event(OTR_Decode *OTR,ETB_fed feds[],int *nhits,
		   OTrWire **wires[],int Nfeds) {
int i;
unsigned short fedid;
unsigned char *tdcdata;
static OTrWire **hitchannels = 0;
OTrTDC *tdc;
OTrASD8 **asdIt;
int asdid,chanid;
OTrWire* chanIt ; 
unsigned short* gedeindexIt ; 
OTrGede* gedeIt ;
OTrGedeWire* wireIt ;
 
  if(hitchannels==0) hitchannels=malloc(sizeof(OTrWire*)*MAXASD*16);
  *nhits=0;
  
  /* reset everything: set first bit of status flag to show that there
     was not data for channel processed */
  for(asdIt=OTR->ASD8s; *asdIt != 0; asdIt++)
    for(chanIt=(*asdIt)->wire; chanIt !=(*asdIt)->wire+16 ; chanIt++) {
      chanIt->dtime = 0; /* not needed anymore: we check on status flag ... */
      chanIt->status |= 0x80 ; /* set last bit: channel not read ... */
    } 
  
  /* read everything */
  for(i=0;i<Nfeds;i++){
    fedid=feds[i].hdr.fedid;
    /* check if good eventrecord and if fed connected */
    if( ((feds[i].hdr.recid & 0Xff00)==RID_NORMAL_FEDRAW) &&
	OTR->FEDs[fedid]!=MAXFED) {
      tdc=OTR->TDCs[OTR->FEDs[fedid]];
      if(tdc) {
	tdcdata=(unsigned char *)feds[i].data;
	chanid=0;
	for(asdid=0;asdid<8;asdid++) { 
	  asdIt = OTR->ASD8s + tdc->ASD[asdid] ;
	  if(/*(tdc->ASD[asdid] != MAXASD) && */
	     (tdc->ASD[asdid] != MAXFED) 
	     && *asdIt)
	    for(chanid=0;chanid<16;chanid++) {
	      (*asdIt)->wire[chanid].dtime  = tdcdata[16*asdid+chanid];
	      (*asdIt)->wire[chanid].status &= 0x7F ; /* unset last bit */
	    }
	}
      }
    }
#ifdef __OTR_DEBUG__
    else {
      printf("skipped FED block %d , recid = %0x",fedid,feds[i].hdr.recid) ;
    }
#endif
  }
  
  /* create hitwires */
  *nhits = 0;
  for(gedeindexIt = OTR->fGedeMap ; 
      gedeindexIt != OTR->fGedeMapEnd ; gedeindexIt++) {
    gedeIt = OTR->fGedes + *gedeindexIt ;
    for(wireIt = gedeIt->fWires; 
	wireIt != gedeIt->fWires + gedeIt->fNWires; wireIt++) {
      if(wireIt->fAsdIndex < MAXASD) {
	chanIt = OTR->ASD8s[wireIt->fAsdIndex]->wire + wireIt->fChannelIndex ;
	if(/*!(chanIt->status) &&*/ chanIt->dtime >1 && chanIt->dtime < 0xfe) {
	  hitchannels[*nhits] = chanIt ;
	  (*nhits)++ ;
	}
      }
    }
  }
  
  *wires=hitchannels ;
  return 1;
}
