
#ifndef __WAX_DSRMANAGER_HH__
#define __WAX_DSRMANAGER_HH__

#ifndef __WAX_BASICTYPES_HH__
#include "BasicTypes.hh"
#endif
#ifndef __SGI_STL_VECTOR
#include <vector>
#endif
#ifndef __STRING__
#include <string>
#endif

class waxRTRelation ;
class waxGedeManager ;


class waxDSRManager
{
public:
  //typedefs
  typedef std::vector<waxRTRelation*> DSRContainer ;
  typedef int RTIndex_t ;
 
  // constructors, destructor
  static waxDSRManager* GetMe() ;
  static void DeleteMe() ;
  ~waxDSRManager() ;

  // setters and getters
  static void SetConfigDirName(const string& dir) { fgConfigDirName = dir ; }
  DSRContainer& GetRTRelations() { return fRTRelations ; }
  waxRTRelation* GetRTRelationFromRTIndex(RTIndex_t rti) {
    return fRTRelations[rti-fRTIndexMin] ; }
  RTIndex_t GetRTIndexMin() const { return fRTIndexMin ; }

  // IO
  void ReadDB() ;
  void WriteDB() ;

  // temporary
  waxRTRelation* GetRTRelation05mm() { return fRTRelations[0] ; }
  waxRTRelation* GetRTRelation10mm() { return fRTRelations[1] ; }
  waxRTRelation* GetRTRelation05mmMagnet() { return fRTRelations[2] ; }
  waxRTRelation* GetRTRelation10mmMagnet() { return fRTRelations[3] ; }
  waxRTRelation* GetMCRTRelation05mm() { return fMCRTRelation05mm ; }
  waxRTRelation* GetMCRTRelation10mm() { return fMCRTRelation10mm ; }
protected:
  waxDSRManager() ;
private:
  void SetRTRelation05mm(waxRTRelation* rtr) { fRTRelations[0] = rtr ; }
  void SetRTRelation10mm(waxRTRelation* rtr) { fRTRelations[1] = rtr ; }
  void SetRTRelation05mmMagnet(waxRTRelation* rtr) { fRTRelations[2] = rtr ; }
  void SetRTRelation10mmMagnet(waxRTRelation* rtr) { fRTRelations[3] = rtr ; }

  // data
  RTIndex_t fRTIndexMin ;
  DSRContainer fRTRelations ; // the rtrelations
  waxRTRelation* fMCRTRelation05mm ;  // rtrelation 05mm cells for MC
  waxRTRelation* fMCRTRelation10mm ;  // rtrelation 10mm cells for MC
  waxGedeManager* fGedeManager ;
  static std::string fgConfigDirName ;
  static waxDSRManager* fgMe ;
} ;

#endif
