#ifndef __WAX_EVENT_HH__
#define __WAX_EVENT_HH__

#ifndef __SGI_STL_VECTOR
#include <vector>
#endif

#include "etb.h"

class waxHit ;
class waxDecodeManager ;

class waxEvent
{
public:
  // typedefs, enumerates
  typedef std::vector<waxHit> HitContainer ;

  // constructors, destructor, assignment
  waxEvent() ;
  virtual ~waxEvent() ;

  // setters and getters
  int GetId() const { return fId ; } 
  void SetId(int id) { fId=id ; }
  const HitContainer& GetHits() const { return fHits ; }
  HitContainer& GetHits() { return fHits ; }

  // other methods
  void Next(waxDecodeManager* decodeManager) ;
  //  void Add( waxHit* hit ) ;  // Add a hit o the event
  void DumpHits(std::ostream& os=std::cout) const ;
  void SortHits(); // sort the hits per superlayer according to GEDE index and x

#ifdef USE_ARTE
  void AppendHITB() ;  // append hits to the HITB bank
#endif

private:
  int fId ;             // Event id 
  HitContainer fHits ;  // Measured hits
  EVENT_HDR *fEventHdr ;
} ;

#endif
